function EFFECT:Init(data)
	self.startPos = data:GetStart()
	self.endPos = data:GetOrigin()
	local clr = data:GetAngles()
	self.entity = data:GetEntity()

	self.color = Color(clr.x, clr.y, clr.z)

	self.dieTime = CurTime() + 0.05

	self:SetRenderBoundsWS(self.startPos, self.endPos)
end

function EFFECT:Think()
	return CurTime() < self.dieTime
end

function EFFECT:Render()
	if not self.entity:IsValid() then return end

	render.SetMaterial(Material("effects/laser1"))
	render.DrawBeam(self.entity:GetPos() + self.startPos, self.endPos, math.Rand(1, 4), 1, math.Rand(1, 5), self.color)

	render.SetMaterial(Material("sprites/glow04_noz"))
	render.DrawSprite(self.endPos, 80, 80, self.color)
end
