AddCSLuaFile()

ENT.Base = "drone_two_entity"
ENT.PrintName		= "Bomb Drone"
ENT.Category        = "Drones 2: Light"
ENT.Spawnable = true

ENT.Speed = 700
ENT.armor = 50
ENT.forward = 80
ENT.up = 15
ENT.cam_up = 20
ENT.MaxFuel = 120
ENT.PropellersPitch = 55
ENT.Noise = false

ENT.HUD_hudColor = Color(255, 0, 0)
ENT.HUD_textColor = Color(255, 100, 0)
ENT.HUD_drawCrosshair = false

ENT.UseAmmo = false

function ENT:Initialize()
	self:_Initialize("models/Combine_Helicopter/helicopter_bomb01.mdl", 100)

	if CLIENT then
		self:SetElements({
			["m"] = { type = "Model", model = "models/Combine_Helicopter/helicopter_bomb01.mdl", bone = "", rel = "", pos = Vector(0, 0, 0), angle = Angle(0, 0, 90), size = Vector(1, 1, 1), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m1"] = { type = "Model", model = "models/mechanics/wheels/wheel_smooth_24.mdl", bone = "", rel = "", pos = Vector(0, 13, 0), angle = Angle(0, 0, 90), size = Vector(1, 1, 1), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001", skin = 0, bodygroup = {} },
			["m2"] = { type = "Model", model = "models/mechanics/wheels/wheel_smooth_24.mdl", bone = "", rel = "", pos = Vector(0, -13, 0), angle = Angle(0, 0, 90), size = Vector(1, 1, 1), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001", skin = 0, bodygroup = {} },
			["m3"] = { type = "Model", model = "models/props_combine/combine_mine01.mdl", bone = "", rel = "", pos = Vector(0, 0, 0), angle = Angle(0, 0, 90), size = Vector(1, 1, 1), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["m4"] = { type = "Model", model = "models/props_combine/combine_mine01.mdl", bone = "", rel = "", pos = Vector(0, 0, 0), angle = Angle(0, 0, -90), size = Vector(1, 1, 1), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
		})
	
		return
	end
end

function ENT:OnDestroyed()	
	local ef = EffectData()
	ef:SetOrigin(self:GetPos())
	
	if self.ShouldConsumeFuel then
		ef:SetScale((self.Fuel + 5) * 0.02)
		util.BlastDamage(self, self, self:GetPos(), (500 * (self.Fuel + 5)) * 0.02, (800 * (self.Fuel + 5)) * 0.01)
	else
		ef:SetScale(2.1)
		util.BlastDamage(self, self, self:GetPos(), 1300, 1040)
	end
	
	util.Effect("effect_rockboom", ef)

	self:EmitSound("ambient/explosions/explode_"..math.random(1,4)..".wav", 500, 100)

	SafeRemoveEntity(self)
end

function ENT:Think()
	self:_Think()

	if SERVER then
	local user = self:GetDriver()
		if user:IsValid()  then
			if user:KeyDown(IN_ATTACK) and CurTime() > self.nextshoot and self:HasFuel() then
				self.nextshoot = CurTime() + 2

				self:OnDestroyed()
			end
		end
	end

	self:NextThink(CurTime())
	return true
end