AddCSLuaFile()

ENT.Base = "drone_two_entity"
ENT.PrintName		= "Missile Drone Mark II"
ENT.Category        = "Drones 2: Heavy"
ENT.Spawnable = true

ENT.Speed = 300
ENT.armor = 400

ENT.forward = 70
ENT.up = 5
ENT.cam_up = 13

ENT.Noise = false

ENT.Mark = 2

ENT.EnableParticles = true
ENT.NumParticles = 4
ENT.ParticleSize = 6
ENT.ParticleRadius = 5
ENT.PosParticles = { Vector(-18, -18, -4), Vector(-18, 18, -4), Vector(18, 18, -4), Vector(18, -18, -4) }

ENT.UseAmmo = false

ENT.Ammo = 30
ENT.MaxAmmo = 30
ENT.AmmoBox = 1
ENT.AmmoType = "item_rpg_round"
ENT.UseAmmo = true

ENT.SoundName = "hl1/ambience/alien_minddrill.wav"
ENT.PropellersPitch = 255

function ENT:Initialize()
	self:_Initialize("models/props_phx/construct/metal_plate1.mdl", 250)

	if CLIENT then
		self:SetElements({
	        ["canpart+++"] = { type = "Model", model = "models/props_c17/display_cooler01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-12.129, 0, 2.628), angle = Angle(0, 90, 0), size = Vector(0.045, 0.549, 0.07), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
	        ["2baz++"] = { type = "Model", model = "models/mechanics/solid_steel/steel_support_24_4.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, 0), angle = Angle(0, 45, 0), size = Vector(0.202, 0.175, 0.111), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
	        ["cou"] = { type = "Model", model = "models/mechanics/solid_steel/type_a_2_8.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, 0), angle = Angle(0, 45, 0), size = Vector(0.519, 0.841, 0.841), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
	        ["cou2++++++"] = { type = "Model", model = "models/mechanics/solid_steel/type_c_3_6.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 10, 2.772), angle = Angle(30, -90, -90), size = Vector(0.2, 0.2, 1.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
	        ["can"] = { type = "Model", model = "models/props_junk/metalgascan.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, -12.87, -2.142), angle = Angle(-180, 0, -90), size = Vector(0.899, 0.512, 0.796), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
	        ["cou2+++++++"] = { type = "Model", model = "models/mechanics/solid_steel/type_c_3_6.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, -10, 2.772), angle = Angle(30, 90, -90), size = Vector(0.2, 0.2, 1.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
	        ["fzz+"] = { type = "Model", model = "models/Items/combine_rifle_ammo01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-17.661, 17.656, 6.677), angle = Angle(-180, 45.79, 0), size = Vector(1.074, 1.618, 1.074), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
	        ["baz"] = { type = "Model", model = "models/XQM/Rails/trackball_1.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, 0), angle = Angle(0, 0, 0), size = Vector(0.892, 0.892, 0.492), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
	        ["fzz+++"] = { type = "Model", model = "models/Items/combine_rifle_ammo01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-17.661, -17.657, 6.677), angle = Angle(-180, -45.791, 0), size = Vector(1.074, 1.618, 1.074), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
	        ["canpart++"] = { type = "Model", model = "models/props_c17/display_cooler01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(12.128, 0, 2.628), angle = Angle(0, -90, 0), size = Vector(0.045, 0.549, 0.07), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
	        ["cou2++++"] = { type = "Model", model = "models/mechanics/solid_steel/type_c_3_6.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(10, 0, 2.772), angle = Angle(30, 0, -90), size = Vector(0.2, 0.2, 1.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
	        ["cou+"] = { type = "Model", model = "models/mechanics/solid_steel/type_a_2_8.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, 0), angle = Angle(0, -45, 0), size = Vector(0.519, 0.841, 0.841), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
	        ["canpart+"] = { type = "Model", model = "models/props_c17/display_cooler01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 12.128, 2.628), angle = Angle(0, 180, 0), size = Vector(0.045, 0.549, 0.07), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
	        ["can++"] = { type = "Model", model = "models/props_junk/metalgascan.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(12.869, 0, -2.142), angle = Angle(0, 90, 90), size = Vector(0.899, 0.512, 0.796), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
	        ["fzz++"] = { type = "Model", model = "models/Items/combine_rifle_ammo01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(17.66, -17.657, 6.677), angle = Angle(-180, 45.79, 0), size = Vector(1.074, 1.618, 1.074), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
	        ["canpart"] = { type = "Model", model = "models/props_c17/display_cooler01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, -12.129, 2.628), angle = Angle(0, 0, 0), size = Vector(0.045, 0.549, 0.07), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
	        ["fzz"] = { type = "Model", model = "models/Items/combine_rifle_ammo01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(17.66, 17.656, 6.677), angle = Angle(-180, -45.791, 0), size = Vector(1.074, 1.618, 1.074), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
	        ["can+++"] = { type = "Model", model = "models/props_junk/metalgascan.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-12.87, 0, -2.142), angle = Angle(0, -90, 90), size = Vector(0.899, 0.512, 0.796), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
	        ["can+"] = { type = "Model", model = "models/props_junk/metalgascan.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 12.869, -2.142), angle = Angle(0, 0, 90), size = Vector(0.899, 0.512, 0.796), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
	        ["cou2+++++"] = { type = "Model", model = "models/mechanics/solid_steel/type_c_3_6.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-10, 0, 2.772), angle = Angle(60, 0, -90), size = Vector(0.2, 0.2, 1.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
	        ["2baz+"] = { type = "Model", model = "models/mechanics/solid_steel/steel_support_24_4.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, 0), angle = Angle(0, -45, 0), size = Vector(0.202, 0.175, 0.111), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} }
   		})
	
		return
	end

	self.gun = ents.Create("rocketgun_d2ent")
	self.gun:SetPos(self:GetPos() + self:GetForward() * -2 + self:GetUp() * -5 + self:GetRight() * -5)
	self.gun:SetAngles(self:GetAngles())
	self.gun:Spawn()
	self.gun:SetSolid(SOLID_NONE)
	self.gun:SetParent(self)
	self.gun._Think = function()
		local user = self:GetDriver()

		if not self:IsDroneDestroyed() and self:HasFuel() and user:IsValid() then		
			if user:KeyDown(IN_ATTACK) and self:HasAmmo() then
				if CurTime() > self.nextshoot then
					local ammo = ents.Create("rocket_dent")
					ammo:SetPos(self.gun:GetPos())
					ammo:SetOwner(self.Owner)
					ammo:SetAngles(self.gun:GetAngles())
					ammo:Spawn()
				
					self.gun:EmitSound("weapons/rpg/rocketfire1.wav")
				
					local physamm = ammo:GetPhysicsObject()
					if IsValid(physamm) then physamm:EnableGravity(false) end 
				
					physamm:AddVelocity(self:GetDriverDirection() * 5000)

					self:SetAmmo(self.Ammo - 1)

					self.nextshoot = CurTime() + 0.7
				end
			end

			self.gun:SetAngles(self:GetAngles() + Angle(user:EyeAngles().p < 0 and 0 or user:EyeAngles().p, user:EyeAngles().y, 0))
		end
	end
end

function ENT:Think()
	self:_Think()

	if CLIENT then
		if self:HasFuel() and not self:IsDroneDestroyed() then
			
		end

		return 
	end

	if self.gun:IsValid() then self.gun._Think() end

	self:NextThink(CurTime())
	return true
end