AddCSLuaFile()

ENT.Base = "drone_two_entity"
ENT.PrintName		= "Scout Drone"
ENT.Category        = "Drones 2: Light"
ENT.Spawnable = true

ENT.Speed = 1000
ENT.armor = 150

ENT.forward = 60
ENT.up = 5
ENT.cam_up = 13

ENT.Ammo = 200
ENT.MaxAmmo = 500
ENT.AmmoBox = 20
ENT.AmmoType = "item_ammo_pistol"
ENT.UseAmmo = true

function ENT:Initialize()
	self:_Initialize("models/props_phx/construct/metal_plate1.mdl", 100)

	if CLIENT then
		self:SetElements({
			["steel"] = { type = "Model", model = "models/mechanics/solid_steel/plank_4.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, -3.04, 3.161), angle = Angle(0, 0, 45), size = Vector(0.043, 0.203, 0.43), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["ta"] = { type = "Model", model = "models/props_junk/TrashBin01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, 2.589), angle = Angle(90, 0, 0), size = Vector(0.184, 0.259, 0.354), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["steel+"] = { type = "Model", model = "models/mechanics/solid_steel/plank_4.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 3.039, 3.161), angle = Angle(0, 0, -45), size = Vector(0.043, 0.203, 0.43), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["baze2+"] = { type = "Model", model = "models/props_combine/combine_bunker01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-1.456, 0, 0.8), angle = Angle(-122.229, -90, 0), size = Vector(0.027, 0.039, 0.027), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["baze4"] = { type = "Model", model = "models/props_combine/combinebutton.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(8.713, 0.953, 0.808), angle = Angle(0, 0, 0), size = Vector(0.31, 0.31, 0.31), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["baze2"] = { type = "Model", model = "models/props_combine/combine_bunker01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-1.456, 0, 0.8), angle = Angle(122.228, -90, 0), size = Vector(0.027, 0.039, 0.027), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["baze"] = { type = "Model", model = "models/props_c17/playgroundtick-tack-toe_block01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, 0), angle = Angle(0, -90, 0), size = Vector(0.5, 1.473, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001", skin = 0, bodygroup = {} },
			["baze3"] = { type = "Model", model = "models/props_combine/masterinterface.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-11.509, 0, 3.611), angle = Angle(-180, 0, 0), size = Vector(0.046, 0.046, 0.032), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["cur"] = { type = "Model", model = "models/props_phx/construct/metal_plate_curve360.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 11.987, 5.81), angle = Angle(0, 0, 0), size = Vector(0.123, 0.123, 0.028), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["cur+"] = { type = "Model", model = "models/props_phx/construct/metal_plate_curve360.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, -11.988, 5.81), angle = Angle(0, 0, 0), size = Vector(0.123, 0.123, 0.028), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["str"] = { type = "Model", model = "models/props_wasteland/panel_leverHandle001a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-5.27, 0, 3.085), angle = Angle(-25.785, -180, 0), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["plat+"] = { type = "Model", model = "models/hunter/plates/plate1x1.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 11.947, 6.578), angle = Angle(0, 0, 0), size = Vector(0.233, 0.233, 0.009), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/airboat/airboat_blur02", skin = 0, bodygroup = {} },
			["plat"] = { type = "Model", model = "models/hunter/plates/plate1x1.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, -11.948, 6.578), angle = Angle(0, 0, 0), size = Vector(0.233, 0.233, 0.009), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/airboat/airboat_blur02", skin = 0, bodygroup = {} }
		})
	
		return
	end

	self.gun = ents.Create("scoutpistol_d2ent")
	self.gun:SetPos(self:GetPos() + self:GetUp() * -5)
	self.gun:SetAngles(self:GetAngles())
	self.gun:Spawn()
	self.gun:SetSolid(SOLID_NONE)
	self.gun:SetParent(self)
	self.gun._Think = function()
		--Minigun and savers
		local user = self:GetDriver()

		if not self:IsDroneDestroyed() and self:HasFuel() and user:IsValid() then	
			if user:KeyDown(IN_ATTACK) and self:HasAmmo() then
				if CurTime() > self.nextshoot then
					local bullet = {}
					bullet.Num = 1
					bullet.Src = self.gun:GetPos() + self.gun:GetForward() * 20
					bullet.Dir = self:GetDriverDirection()
					bullet.Spread = Vector(0.01, 0.01, 0.01)
					bullet.Tracer = 2	
					bullet.Force = 15
					bullet.Damage = 5
					bullet.Attacker = self.Owner
					 
					user:EmitSound("weapons/pistol/pistol_fire2.wav", 100, 100)

					self.gun:FireBullets(bullet)

					self:SetAmmo(self.Ammo - 1)

					self.nextshoot = CurTime() + 0.3
				end
			end

			self.gun:SetAngles(self:GetAngles() + Angle(user:EyeAngles().p < 0 and 0 or user:EyeAngles().p, user:EyeAngles().y, 0))
		end
	end
end

function ENT:Think()
	self:_Think()

	if CLIENT then
		if self:HasFuel() and not self:IsDroneDestroyed() then
			self.WElements["plat"].angle = Angle(0, CurTime() * 1500, 0)
			self.WElements["plat+"].angle = Angle(0, CurTime() * 1500, 0)
		end

		return 
	end

	if self.gun:IsValid() then self.gun._Think() end

	self:NextThink(CurTime())
	return true
end