AddCSLuaFile()

ENT.Base = "drone_two_entity"
ENT.PrintName		= "Sniper Drone"
ENT.Category        = "Drones 2: Light"
ENT.Spawnable = true

ENT.Speed = 700
ENT.armor = 150

ENT.forward = 60
ENT.up = 5
ENT.cam_up = 18
ENT.cam_forward = 10

ENT.HUD_drawCrosshair = false
ENT.enableDefaultZoom = false
ENT.Mark = 2

ENT.EnableParticles = true
ENT.NumParticles = 4
ENT.ParticleSize = 6
ENT.ParticleRadius = 2
ENT.PosParticles = { Vector(-12, -3, -8), Vector(-12, 3, -8), Vector(5, 3, -8), Vector(5, -3, -8) }
ENT.VelocityParticles = { Vector(-12, 0, 0), Vector(-12, 0, 0) }

ENT.Invisibility = 100
ENT.EnableSound = false

ENT.Ammo = 30
ENT.MaxAmmo = 30
ENT.AmmoBox = 10
ENT.AmmoType = "item_ammo_357"
ENT.UseAmmo = true

ENT.CustomHUD = function(drone, x, y)
	if drone:GetNWBool("scoped") then
		local x, y = ScrW() / 2, ScrH() / 2

		surface.SetMaterial(Material("particles/dronestwo_ring"))
		surface.SetDrawColor(Color(0, 0, 0, 255))

		local size = 1600
		surface.DrawLine(0, y - 10, ScrW(), y - 10)
		surface.DrawLine(x, 0, x, ScrH())
		surface.DrawTexturedRect(x - (size/2), y - (size/2), size, size)
	end

	if drone:GetNWEntity("bak"):IsValid() then
		draw.SimpleText("Invisibility " .. math.floor(drone.Invisibility) .. "%", "Trebuchet24", x + 200, y - 85, drone.HUD_textColor, TEXT_ALIGN_RIGHT)

		surface.SetDrawColor(drone.HUD_hudColor)
		surface.DrawOutlinedRect(x + 215, y - 80, 200, 15)
		surface.DrawRect(x + 220, y - 75, drone.Invisibility * 1.9, 5)
	else
		draw.SimpleText("Invisibility was broken", "Trebuchet24", x + 200, y - 85, drone.HUD_textColor, TEXT_ALIGN_RIGHT)
	end
end

if CLIENT then
	usermessage.Hook("dronestwo_sniper_i", function(data)
		local self = data:ReadEntity()
		local invisibility = data:ReadFloat()

		if not self:IsValid() then return end

		self.Invisibility = invisibility
	end)
else
	function ENT:SetInvisiblelvl(n)
		if n <= 0 then 
			self.Invisible = false
			self:SetNoDraw(false)
			if self.gun:IsValid() then self.gun:SetNoDraw(false) end
			if self.bak:IsValid() then self.bak:SetNoDraw(false) end
		end

		self.Invisibility = math.min(100, n)

		umsg.Start("dronestwo_sniper_i")
			umsg.Entity(self)
			umsg.Float(self.Invisibility)
		umsg.End()
	end
end

function ENT:SetScoped(n)
	if SERVER then
		local user = self:GetDriver()

		if user:IsValid() then
			self.Scoped = n
			if n then
				self.Speed = 100
				self:SetNWBool("scoped", true)
				user:SetFOV(20, 0)
			else
				self.Speed = 700
				self:SetNWBool("scoped", false)
				user:SetFOV(90, 0)
			end
		end
	end
end

function ENT:OnDriverSet()
	self:SetScoped(false)
end

function ENT:OnDestroyed()
	self:SetNoDraw(false)
	if self.gun:IsValid() then self.gun:SetNoDraw(false) end
end

function ENT:Initialize()
	self:_Initialize("models/props_phx/construct/metal_plate1.mdl", 200)

	if CLIENT then
		self:SetElements({
			["barx+"] = { type = "Model", model = "models/props_combine/combine_barricade_med02a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-3.863, 4.741, -7.336), angle = Angle(-24.439, -95.055, -3.428), size = Vector(0.064, 0.193, 0.064), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["tur"] = { type = "Model", model = "models/combine_turrets/ground_turret.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(6.276, 0.639, -0.912), angle = Angle(-10.521, 0, 0), size = Vector(0.602, 0.5, 0.463), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001", skin = 0, bodygroup = {} },
			["barx2"] = { type = "Model", model = "models/props_combine/combine_barricade_med02a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(8.44, 5.916, -4.502), angle = Angle(-9.037, -45, -180), size = Vector(0.046, 0.025, 0.046), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["soplo+"] = { type = "Model", model = "models/Items/combine_rifle_ammo01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-10.704, -2.175, -5.574), angle = Angle(128.927, 0, 0), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["lodko22+"] = { type = "Model", model = "models/hunter/tubes/circle2x2d.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(4.447, 7.041, -4.364), angle = Angle(1.809, -151.586, -7.077), size = Vector(0.31, 0.31, 0.347), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/masterinterface_disp", skin = 0, bodygroup = {} },
			["bar23"] = { type = "Model", model = "models/props_combine/combine_barricade_med02a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(13.348, 0, -4.907), angle = Angle(-144.7, -180, 0), size = Vector(0.054, 0.05, 0.059), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["bar23+"] = { type = "Model", model = "models/props_combine/combine_barricade_med02a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(10.432, -2.422, -7.883), angle = Angle(-144.7, -150.892, 23.271), size = Vector(0.039, 0.039, 0.039), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["barx2+"] = { type = "Model", model = "models/props_combine/combine_barricade_med02a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(8.44, -5.789, -4.502), angle = Angle(-5.502, 39.4, 180), size = Vector(0.046, 0.025, 0.046), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["bar"] = { type = "Model", model = "models/props_combine/combine_barricade_med02c.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-8.266, 0, -6.398), angle = Angle(-102.583, 0, 0), size = Vector(0.107, 0.107, 0.131), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["barx"] = { type = "Model", model = "models/props_combine/combine_barricade_med02a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-3.863, -4.742, -7.336), angle = Angle(-24.439, 95.054, 3.427), size = Vector(0.064, 0.193, 0.064), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["tur+"] = { type = "Model", model = "models/combine_turrets/ground_turret.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(13.616, 0.264, -3.955), angle = Angle(-10.521, 0, 0), size = Vector(0.18, 0.159, 0.18), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001", skin = 0, bodygroup = {} },
			["emit+"] = { type = "Model", model = "models/props_combine/combine_emitter01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-5.956, 0, -2.302), angle = Angle(0, 0, 20.676), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["emit"] = { type = "Model", model = "models/props_combine/combine_emitter01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-5.956, 0, -2.302), angle = Angle(0, 0, -20.677), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["soplo++"] = { type = "Model", model = "models/Items/combine_rifle_ammo01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(4.078, -3.215, -6.207), angle = Angle(171.242, 0, 0), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["prot+++"] = { type = "Model", model = "models/props_combine/combine_barricade_med01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-11.072, 5.208, -3.336), angle = Angle(-4.213, -100.787, 0), size = Vector(0.074, 0.15, 0.039), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["bar2"] = { type = "Model", model = "models/props_combine/combine_barricade_med02a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(6.346, 0, -8.448), angle = Angle(-68.25, 180, 0), size = Vector(0.059, 0.098, 0.118), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["soplo"] = { type = "Model", model = "models/Items/combine_rifle_ammo01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-10.704, 2.174, -5.574), angle = Angle(128.927, 0, 0), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["prot+"] = { type = "Model", model = "models/props_combine/combine_barricade_med01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-0.011, 5.69, -4.803), angle = Angle(-4.62, -87.46, 0), size = Vector(0.074, 0.238, 0.074), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001", skin = 0, bodygroup = {} },
			["prot"] = { type = "Model", model = "models/props_combine/combine_barricade_med01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-11.072, -5.329, -3.336), angle = Angle(-4.213, 104.134, 0), size = Vector(0.074, 0.166, 0.039), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["lodko22"] = { type = "Model", model = "models/hunter/tubes/circle2x2d.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(4.521, -6.993, -4.022), angle = Angle(-6.434, 61.93, 2.592), size = Vector(0.31, 0.31, 0.395), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/masterinterface_disp", skin = 0, bodygroup = {} },
			["bar2+"] = { type = "Model", model = "models/props_combine/combine_barricade_med02a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-12.396, 0, -6.176), angle = Angle(-133.769, -0.031, 180), size = Vector(0.059, 0.098, 0.068), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["bar23++"] = { type = "Model", model = "models/props_combine/combine_barricade_med02a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(10.432, 2.262, -7.883), angle = Angle(-144.7, 150.891, -23.272), size = Vector(0.039, 0.039, 0.039), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["prot++"] = { type = "Model", model = "models/props_combine/combine_barricade_med01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-0.011, -5.691, -4.803), angle = Angle(-4.62, 85.272, 0), size = Vector(0.074, 0.238, 0.074), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001", skin = 0, bodygroup = {} },
			["lodko"] = { type = "Model", model = "models/props_canal/boat002b.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, 0), angle = Angle(0, 0, -180), size = Vector(0.273, 0.273, 0.273), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["soplo+++"] = { type = "Model", model = "models/Items/combine_rifle_ammo01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(4.078, 3.214, -6.207), angle = Angle(171.242, 0, 0), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} }
		})
	
		return
	end

	self.bak = ents.Create("invisible_d2ent")
	self.bak:SetPos(self:GetPos() + self:GetUp() * -6 + self:GetForward() * -20)
	self.bak:SetMaterial("models/props_combine/combinethumper002")
	self.bak:SetAngles(self:LocalToWorldAngles(Angle(0, 0, 0)))
	self.bak:Spawn()
	self.bak.Drone = self
	self.bak:SetParent(self)
	self:SetNWEntity("bak", self.bak)

	self.gun = ents.Create("sniperrifle_d2ent")
	self.gun:SetPos(self:GetPos() + self:GetUp() * -14)
	self.gun:SetAngles(self:GetAngles())
	self.gun:Spawn()
	self.gun:SetSolid(SOLID_NONE)
	self.gun:SetParent(self)
	self.gun._Think = function()
		--Minigun and savers
		local user = self:GetDriver()

		if not self:IsDroneDestroyed() and self:HasFuel() and user:IsValid() then		
			if user:KeyDown(IN_ATTACK) and self:HasAmmo() then
				if CurTime() > self.nextshoot then
					local bullet = {}
					bullet.Num = 1
					bullet.Src = self.gun:GetPos() + self.gun:GetForward() * 40
					bullet.Dir = self:GetDriverDirection()
					bullet.Spread = Vector(0, 0, 0)
					bullet.Tracer = 2	
					bullet.Force = 100
					bullet.Damage = 200
					bullet.Attacker = self.Owner
					 
					self.gun:EmitSound("weapons/awp/awp1.wav", 100, 100)

					self.gun:FireBullets(bullet)

					self:SetAmmo(self.Ammo - 1)

					self.nextshoot = CurTime() + 1
				end
			end

			if self.bak:IsValid() and user:KeyDown(IN_WALK) and CurTime() > self.nextshoot then
				self.Invisible = not self.Invisible

				self:SetNoDraw(self.Invisible)
				if self.gun:IsValid() then self.gun:SetNoDraw(self.Invisible) end
				self.bak:SetNoDraw(self.Invisible)

				self:EmitSound("friends/friend_online.wav", 100, 80)
				self.nextshoot = CurTime() + 0.3
			end

			if user:KeyDown(IN_ATTACK2) and CurTime() > self.nextshoot then
				self:SetScoped(not self.Scoped)
				self.nextshoot = CurTime() + 0.3
			end

			self.gun:SetAngles(self:GetAngles() + Angle(user:EyeAngles().p < 0 and 0 or user:EyeAngles().p, user:EyeAngles().y, 0))
		end
	end
end

function ENT:Think()
	self:_Think()

	if CLIENT then
		return 
	end

	if self.Invisible then
		if self.Invisibility > 0 then self:SetInvisiblelvl(self.Invisibility - 0.1) end
	else
		self:SetInvisiblelvl(self.Invisibility + 0.04)
	end

	if self.gun:IsValid() then self.gun._Think() end

	self:NextThink(CurTime())
	return true
end