AddCSLuaFile()

ENT.Base = "drone_two_entity"
ENT.PrintName		= "Spy Drone"
ENT.Category        = "Drones 2: Exploration"
ENT.Spawnable = true

ENT.Speed = 600
ENT.armor = 60

ENT.forward = 10
ENT.cam_up = -3

ENT.EnableSound = true
ENT.MaxFuel = 70

ENT.UseAmmo = false

function ENT:Initialize()
	if CLIENT then
		self:SetElements({
	        ["palk+"] = { type = "Model", model = "models/props_combine/combine_binocular01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-1.4, -1.4, 0), angle = Angle(90, 135, 0), size = Vector(0.101, 0.101, 0.101), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
	        ["palk++"] = { type = "Model", model = "models/props_combine/combine_binocular01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(1.399, 1.399, 0), angle = Angle(90, -45, 0), size = Vector(0.101, 0.101, 0.101), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
	        ["palk"] = { type = "Model", model = "models/props_combine/combine_binocular01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(1.399, -1.4, 0), angle = Angle(90, 45, 0), size = Vector(0.101, 0.101, 0.101), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
	        ["palk+++"] = { type = "Model", model = "models/props_combine/combine_binocular01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-1.4, 1.399, 0), angle = Angle(90, -135, 0), size = Vector(0.101, 0.101, 0.101), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
	        ["plat+++"] = { type = "Model", model = "models/hunter/plates/plate1x1.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(3.302, -3.28, 0.052), angle = Angle(0, 0, 0), size = Vector(0.052, 0.052, 0.009), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/airboat/airboat_blur02", skin = 0, bodygroup = {} },
	        ["plat"] = { type = "Model", model = "models/hunter/plates/plate1x1.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-3.303, 3.279, 0.052), angle = Angle(0, 0, 0), size = Vector(0.052, 0.052, 0.009), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/airboat/airboat_blur02", skin = 0, bodygroup = {} },
	        ["plat++"] = { type = "Model", model = "models/hunter/plates/plate1x1.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(3.302, 3.279, 0.052), angle = Angle(0, 0, 0), size = Vector(0.052, 0.052, 0.009), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/airboat/airboat_blur02", skin = 0, bodygroup = {} },
	        ["bmb"] = { type = "Model", model = "models/Combine_Helicopter/helicopter_bomb01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, 0.542), angle = Angle(0, 0, 0), size = Vector(0.048, 0.048, 0.052), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/masterinterface_disp", skin = 0, bodygroup = {} },
	        ["plat+"] = { type = "Model", model = "models/hunter/plates/plate1x1.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-3.303, -3.28, 0.052), angle = Angle(0, 0, 0), size = Vector(0.052, 0.052, 0.009), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/airboat/airboat_blur02", skin = 0, bodygroup = {} }
   		})
	end

	self:_Initialize("models/hunter/plates/plate.mdl", 150)
end

function ENT:OnDestroyed() end
function ENT:Think()
	self:_Think()

	if CLIENT then
		if self:HasFuel() and not self:IsDroneDestroyed() then
			self.WElements["plat"].angle = Angle(0, CurTime() * 1500, 0)
			self.WElements["plat+"].angle = Angle(0, CurTime() * 1500, 0)
			self.WElements["plat++"].angle = Angle(0, CurTime() * 1500, 0)
			self.WElements["plat+++"].angle = Angle(0, CurTime() * 1500, 0)
		end

		return 
	end

	local user = self:GetDriver()
	if user:IsValid() and self:HasFuel() then
		if user:KeyDown(IN_ATTACK) and CurTime() > self.nextshoot then
			local ent = self:GetAimWithDistance(100).Entity
			if ent:IsValid() then
				ent:Use(self, self, 1, 1)
			end

			self.nextshoot = CurTime() + 0.3
		end

		if user:KeyDown(IN_ATTACK2) and CurTime() > self.nextshoot then
			local ent = self:GetAimWithDistance(100).Entity
			if ent:IsValid() and ent.IS_DRONE then
				if ent.AllowControl then user:ChatPrint("This drone is already hacked. You may drive it") return end
				user:ChatPrint("Hacking started")

				self.Target = ent
				timer.Create("hack_ent" .. self:EntIndex(), 10, 1, function()
					if self:IsValid() and user:IsValid() and self.Target:IsValid() then
						self.Target.AllowControl = true
						user:ChatPrint("Hacked successfully!")
						self.Target = NULL
					end
				end)
			end

			self.nextshoot = CurTime() + 0.3
		end

		if self.Target and self.Target:IsValid() then
			local ent = self:GetAimWithDistance(100).Entity
			if ent != self.Target then 
				user:ChatPrint("You must look at drone which you're hacking and be near it!")
				self.Target = nil 
			end
		end
	end

	self:NextThink(CurTime())
	return true
end

function ENT:DoSound()
	self.Sound = CreateSound(self, self.SoundName)
	self.Sound:Play()
	self.Sound:ChangeVolume(0.3)
end