AddCSLuaFile()

ENT.Base = "drone_two_entity"
ENT.PrintName		= "Warrior Drone Mark II"
ENT.Category        = "Drones 2: Light"
ENT.Spawnable = true

ENT.Speed = 700
ENT.armor = 250

ENT.forward = 60
ENT.up = 5
ENT.cam_up = 13

ENT.Noise = false
ENT.EnableSound = false
ENT.Mark = 2

ENT.EnableParticles = true
ENT.NumParticles = 4
ENT.ParticleSize = 6
ENT.ParticleRadius = 4
ENT.PosParticles = { Vector(-28, -28, -4), Vector(-28, 28, -4), Vector(28, 28, -4), Vector(28, -28, -4) }

ENT.SoundName = "hl1/ambience/alien_minddrill.wav"
ENT.PropellersPitch = 255

ENT.Ammo = 2000

function ENT:Initialize()
	self:_Initialize("models/props_phx/construct/metal_plate1.mdl", 240)

	if CLIENT then
		self:SetElements({
			["m+"] = { type = "Model", model = "models/props_combine/combine_bunker01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, -8), angle = Angle(0, -90, 0), size = Vector(0.059, 0.059, 0.059), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m+++++++"] = { type = "Model", model = "models/props_combine/combinecamera001.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(15, 15, -2.597), angle = Angle(40.909, -45, 0), size = Vector(0.8, 0.8, 0.8), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m2"] = { type = "Model", model = "models/props_combine/combine_binocular01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(20, 20, -1.5), angle = Angle(115, -45, 0), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m2+++"] = { type = "Model", model = "models/props_combine/combine_binocular01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-20, 20, -1.5), angle = Angle(115, -135, 0), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m2++++"] = { type = "Model", model = "models/Items/combine_rifle_ammo01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-25, 25, 1.557), angle = Angle(-150, -135, 0), size = Vector(0.699, 0.699, 0.699), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m++++"] = { type = "Model", model = "models/props_combine/combinecamera001.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(15, -15, -2.597), angle = Angle(40.909, 45, 0), size = Vector(0.8, 0.8, 0.8), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m2+++++++"] = { type = "Model", model = "models/Items/combine_rifle_ammo01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-25, -25, 1.557), angle = Angle(-150, 135, 0), size = Vector(0.699, 0.699, 0.699), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m"] = { type = "Model", model = "models/props_combine/combine_bunker01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, 0), angle = Angle(180, -90, 0), size = Vector(0.059, 0.059, 0.059), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m+++++"] = { type = "Model", model = "models/props_combine/combinecamera001.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-15, -15, -2.597), angle = Angle(40.909, 135, 0), size = Vector(0.8, 0.8, 0.8), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m2++"] = { type = "Model", model = "models/props_combine/combine_binocular01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-20, -20, -1.5), angle = Angle(115, 135, 0), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m++++++++++"] = { type = "Model", model = "models/props_combine/combine_barricade_bracket02b.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(15, -15, -2.597), angle = Angle(-12.858, 60, -90), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m+++++++++"] = { type = "Model", model = "models/props_combine/combine_barricade_bracket02b.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-15, 15, -2.597), angle = Angle(-12.858, -120, -90), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m2+"] = { type = "Model", model = "models/props_combine/combine_binocular01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(20, -20, -1.5), angle = Angle(115, 45, 0), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m2++++++"] = { type = "Model", model = "models/Items/combine_rifle_ammo01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(25, -25, 1.557), angle = Angle(-150, 45, 0), size = Vector(0.699, 0.699, 0.699), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m++++++"] = { type = "Model", model = "models/props_combine/combinecamera001.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-15, 15, -2.597), angle = Angle(40.909, -135, 0), size = Vector(0.8, 0.8, 0.8), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m2+++++"] = { type = "Model", model = "models/Items/combine_rifle_ammo01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(25, 25, 1.557), angle = Angle(-150, -45, 0), size = Vector(0.699, 0.699, 0.699), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["gear"] = { type = "Model", model = "models/props_phx/gears/bevel36.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(5.714, 0, -7.792), angle = Angle(180, 0, 0), size = Vector(0.25, 0.25, 0.25), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001", skin = 0, bodygroup = {} },
			["m++++++++"] = { type = "Model", model = "models/props_combine/combine_barricade_bracket02b.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(15, 15, -2.597), angle = Angle(-12.858, -30, -90), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m+++++++++++"] = { type = "Model", model = "models/props_combine/combine_barricade_bracket02b.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-15, -15, -2.597), angle = Angle(-12.858, 150.779, -90), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m+++"] = { type = "Model", model = "models/props_combine/combine_emitter01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, -1.3), angle = Angle(0, 0, 180), size = Vector(0.497, 0.497, 0.497), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m++"] = { type = "Model", model = "models/props_combine/combine_emitter01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, -3.636), angle = Angle(0, 0, 0), size = Vector(0.497, 0.497, 0.497), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m+++++++++++++++"] = { type = "Model", model = "models/props_combine/breenlight.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0.518, 8.831, -6.5), angle = Angle(90, 0, 0), size = Vector(1.274, 1.274, 1.274), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_tower01a", skin = 0, bodygroup = {} },
			["m+++++++++++++"] = { type = "Model", model = "models/props_combine/breenlight.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0.518, -8.832, -6.5), angle = Angle(90, 0, 0), size = Vector(1.274, 1.274, 1.274), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_tower01a", skin = 0, bodygroup = {} },
			["m++++++++++++++"] = { type = "Model", model = "models/props_combine/breenlight.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0.518, 8.831, 1.557), angle = Angle(90, 0, 0), size = Vector(1.274, 1.274, 1.274), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001", skin = 0, bodygroup = {} },
			["m++++++++++++"] = { type = "Model", model = "models/props_combine/breenlight.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0.518, -8.832, 1.557), angle = Angle(90, 0, 0), size = Vector(1.274, 1.274, 1.274), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001", skin = 0, bodygroup = {} }		
		})
	
		return
	end

	self.gun = ents.Create("minigun_dr2ent")
	self.gun:SetPos(self:GetPos() + self:GetForward() * 10 + self:GetUp() * -10 + self:GetRight() * 10)
	self.gun:SetAngles(self:GetAngles())
	self.gun:Spawn()
	self.gun:SetSolid(SOLID_NONE)
	self.gun:SetParent(self)
	self.gun._Think = function()
		--Minigun and savers
		local user = self:GetDriver()

		if not self:IsDroneDestroyed() and self:HasFuel() and user:IsValid() then	
			if user:KeyDown(IN_ATTACK) and self:HasAmmo() then
				self.gun:Switch(true)

				if CurTime() > self.nextshoot then
					local bullet = {}
					bullet.Num = 1
					bullet.Src = self.gun:GetPos() + self.gun:GetForward() * 20
					bullet.Dir = self:GetDriverDirection()
					bullet.Spread = Vector(0.02, 0.02, 0.02)
					bullet.Tracer = 2	
					bullet.Force = 10
					bullet.Damage = 3
					bullet.Attacker = self.Owner
					 
					user:EmitSound("weapons/pistol/pistol_fire2.wav", 100, math.random(200, 250))

					self.gun:FireBullets(bullet)

					self:SetAmmo(self.Ammo - 1)

					self.nextshoot = CurTime() + 0.01
				end
			else
				self.gun:Switch(false)
			end

			self.gun:SetAngles(self:GetAngles() + Angle(user:EyeAngles().p < 0 and 0 or user:EyeAngles().p, user:EyeAngles().y, 0))
		else
			self.gun:Switch(false)
		end
	end

	self.nextshoot2 = 0
	self.gun2 = ents.Create("minigun_dr2ent")
	self.gun2:SetPos(self:GetPos() + self:GetForward() * 10 + self:GetUp() * -10 + self:GetRight() * -10)
	self.gun2:SetAngles(self:GetAngles())
	self.gun2:Spawn()
	self.gun2:SetSolid(SOLID_NONE)
	self.gun2:SetParent(self)
	self.gun2._Think = function()
		local user = self:GetDriver()

		if not self:IsDroneDestroyed() and self:HasFuel() and user:IsValid() then		
			if user:KeyDown(IN_ATTACK) and self:HasAmmo() then
				self.gun2:Switch(true)
				if CurTime() > self.nextshoot2 then
					local bullet = {}
					bullet.Num = 1
					bullet.Src = self.gun2:GetPos() + self.gun2:GetForward() * 20
					bullet.Dir = self:GetDriverDirection()
					bullet.Spread = Vector(0.03, 0.03, 0.03)
					bullet.Tracer = 2	
					bullet.Force = 10
					bullet.Damage = 10
					bullet.Attacker = self.Owner
					 
					user:EmitSound("weapons/pistol/pistol_fire2.wav", 100, math.random(200, 250))

					self.gun2:FireBullets(bullet)

					self:SetAmmo(self.Ammo - 1)

					self.nextshoot2 = CurTime() + 0.03
				end
			else
				self.gun2:Switch(false)
			end

			self.gun2:SetAngles(self:GetAngles() + Angle(user:EyeAngles().p < 0 and 0 or user:EyeAngles().p, user:EyeAngles().y, 0))
		else
			self.gun2:Switch(false)
		end
	end
end

function ENT:Think()
	self:_Think()
	

	if CLIENT then
		self.WElements["gear"].angle.yaw = CurTime() * 10

		return 
	end

	if self.gun:IsValid() then self.gun._Think() end
	if self.gun2:IsValid() then self.gun2._Think() end

	self:NextThink(CurTime())
	return true
end