AddCSLuaFile()
ENT.Type = "anim"
ENT.Base = "base_anim"
ENT.Spawnable = false
ENT.Mode = nil

function ENT:Draw()
	if SERVER then return end
	self:DrawModel()
end

if CLIENT then return end

function ENT:Initialize()
	self:SetModel("models/dav0r/hoverball.mdl")
	self:SetMoveType(MOVETYPE_VPHYSICS)
	self:SetSolid(SOLID_VPHYSICS)
	self:PhysicsInit(SOLID_VPHYSICS)
	self:GetPhysicsObject():EnableDrag(false) 

	if self.Mode == 2 then 
		timer.Create("explotimes"..self:EntIndex(), 5, 1, function()
			if self:IsValid() then
				self:Boom()
			end
		end)
	end
end

ENT.lvc = 1

function ENT:SetMode(mode)
	self.Mode = mode
end

function ENT:Boom()
	local ef = EffectData()
	ef:SetOrigin(self:GetPos())
	ef:SetAttachment(1)
	ef:SetScale(1)
	ef:SetEntity(self.Weapon)
	util.Effect("effect_rockboom", ef, true, true)	
	
	self:EmitSound("ambient/explosions/explode_"..math.random(1,4)..".wav", 500, 100)
	
	util.BlastDamage( self, self, self:GetPos(), 500, 200 )
	
	util.ScreenShake(self.Entity:GetPos(), 500, 255, 0.5, 1200)
	
	self:Remove()
end

function ENT:Think()
	self:NextThink(CurTime())
end

function ENT:PhysicsCollide(data,physobj)
	if self.Mode == 1 then
		self:Boom()
	end
	
	if self.Mode == 3 then
		if data.HitEntity:IsValid() then 
			self.Entity:SetParent(data.HitEntity)
			physobj:EnableMotion(false)		
			self:SetSolid(SOLID_NONE)
		else
			physobj:EnableMotion(false)		
			self:SetSolid(SOLID_NONE)
		end
	end
end