if SERVER then AddCSLuaFile() end

function EFFECT:Init(data)
	self.Start = data:GetOrigin()
	self.size = data:GetScale()
	self.Emitter = ParticleEmitter(self.Start)
	
	for i = 1, 200 do
		local p = self.Emitter:Add("particle/smokesprites_000" .. math.random(1, 9), self.Start)

		p:SetDieTime(math.Rand(0.1, 0.3))
		p:SetStartAlpha(80)
		p:SetEndAlpha(0)
		p:SetStartSize(math.random(150, 200) * self.size)
		p:SetEndSize(150 * self.size)
		p:SetRoll(math.Rand(-1, 1))
		p:SetRollDelta(math.Rand(-1, 1))
		p:SetCollide(true)
			
		p:SetVelocity(VectorRand():GetNormal() * 2500 * self.size)
		p:SetColor(0, math.random(0,255), math.random(0,255))
			
		//timer.Simple(0.5, function() p:SetVelocity(p:GetVelocity() / 4) end)
	end
	
	for i = 1, 100 do
		local p = self.Emitter:Add("particle/smokesprites_000" .. math.random(1, 9), self.Start)

		p:SetDieTime(math.Rand(0.5, 2))
		p:SetStartAlpha(80)
		p:SetEndAlpha(0)
		p:SetStartSize(math.random(150, 200) * self.size)
		p:SetEndSize(50 * self.size)
		p:SetRoll(math.Rand(-1, 1))
		p:SetRollDelta(math.Rand(-1, 1))
		p:SetCollide(true)
			
		p:SetVelocity(VectorRand():GetNormal() * 250 * self.size)
		p:SetColor(0, math.random(0,255), math.random(0,255))
	end
		
	for i = 1, math.random(20, 50) do
		local p = self.Emitter:Add("effects/muzzleflash"..math.random(1,4), self.Start)

		p:SetDieTime(math.Rand(0.4, 0.6))
		p:SetStartAlpha(60)
		p:SetEndAlpha(0)
		p:SetStartSize(math.random(50, 150) * self.size)
		p:SetEndSize(50 * self.size)
		//p:SetRoll(math.Rand(-10, 10))
		//p:SetRollDelta(math.Rand(-10, 10))
		p:SetCollide(true)
			
		p:SetVelocity(VectorRand():GetNormal() * math.random(150, 350) * self.size)
		p:SetColor(0, 255, 0)
	end
		
	local vec = VectorRand():GetNormal()
	//vec.z = 0
	local pos = (self.Start + vec)
		
	local p = self.Emitter:Add("particle/warp1_warp", self.Start + vec * 100)

	p:SetDieTime(math.Rand(1, 3))
	p:SetStartAlpha(255)
	p:SetEndAlpha(0)
	p:SetStartSize(math.random(450, 700) * self.size)
	p:SetRoll(math.Rand(-10, 10))
	p:SetRollDelta(math.Rand(-10, 10))
	p:SetEndSize(0 * self.size)
	p:SetCollide(true)
		
	for i = 1, math.random(40, 70) do
		local vec = VectorRand():GetNormal()
		vec.z = 0
		local pos = (self.Start + vec * 5)
		
		local p = self.Emitter:Add("sprites/orangeflare1", self.Start + vec * 100)
			
		p:SetDieTime(math.Rand(1, 5))
		p:SetStartAlpha(255)
		p:SetEndAlpha(0)
		p:SetStartSize(50 * self.size)
		p:SetEndSize(0 * self.size)
		p:SetVelocity(((pos - self.Start):GetNormal() * math.random(100, 200)) + Vector(0, 0, math.random(-200, 500)) * self.size)
		p:SetGravity(Vector(0, 0, -40))
		p:SetColor(0, math.random(0,255), math.random(0,255))
		p:SetCollide(true)
		
		timer.Simple(0.5, function() p:SetVelocity(p:GetVelocity() / 3) end)
	end
	
	self.Emitter:Finish()
end

function EFFECT:Think()
	return false
end

function EFFECT:Render()
end