if SERVER then AddCSLuaFile() end

function EFFECT:Init(data)
	self.Start = data:GetOrigin() + Vector(math.random(0, 100), math.random(0, 100), math.random(0, 100))
	self.size = 1
	self.Emitter = ParticleEmitter(self.Start)
	
	local RandVec = VectorRand():GetNormal()
	
	for i = 1, 100 do
		local p = self.Emitter:Add("particle/smokesprites_000" .. math.random(1, 9), self.Start)

		p:SetDieTime(math.Rand(1, 2))
		p:SetStartAlpha(80)
		p:SetEndAlpha(0)
		p:SetStartSize(100 - i )
		p:SetEndSize(p:GetStartSize())
		p:SetRoll(math.Rand(-1, 1))
		p:SetRollDelta(math.Rand(-1, 1))
		p:SetCollide(true)
		p:SetGravity(Vector(0, 0, -2 * i))
		
		p:SetVelocity(RandVec * 5000 * self.size)
		p:SetColor(100, 100, 100)
		
		timer.Simple(0.01 * (i/4.5), function() p:SetVelocity(p:GetVelocity() * 0) end)
	end
	
	self.Emitter:Finish()
end

function EFFECT:Think()
	return false
end

function EFFECT:Render()
end