AddCSLuaFile()

ENT.Type = "anim"
ENT.Base = "base_anim"
ENT.Spawnable = false
ENT.HP = 20
ENT.Drone = NULL

function ENT:Draw()
	if SERVER then return end

	self:DrawModel()
end

function ENT:Initialize()
	if CLIENT then return end

	self:SetModel("models/props_junk/PropaneCanister001a.mdl")
	self:SetMoveType(MOVETYPE_VPHYSICS)
	self:SetSolid(SOLID_VPHYSICS)
	self:PhysicsInit(SOLID_VPHYSICS)
	self:DrawShadow(false)
end

function ENT:OnTakeDamage(dmg)
	self.HP = self.HP - dmg:GetDamage()

	if self.HP <= 0 then
		--util.BlastDamage(self, self, self:GetPos(), 500, 800)

		local ef = EffectData()
		ef:SetOrigin(self:GetPos())
		ef:SetScale(1)
		local efn = "effect_rockboom"
		if self.Drone:GetClass() == "drone_refuelplasma" then efn = "dronestwo_plasmaboom" end
		util.Effect(efn, ef)

		self:EmitSound("ambient/explosions/explode_"..math.random(1,4)..".wav", 500, 100)

		SafeRemoveEntity(self)
		SafeRemoveEntity(self.Drone)
	end
end