AddCSLuaFile()

ENT.Base = "drone_two_entity"
ENT.PrintName		= "Cargo Drone Mark II"
ENT.Category        = "Drones 2: Support"
ENT.Spawnable = true

ENT.Speed = 300
ENT.armor = 600

ENT.forward = 100
ENT.up = 30
ENT.cam_up = 22

ENT.Noise = false

ENT.MaxFuel = 400
ENT.Mark = 2

ENT.EnableParticles = true
ENT.NumParticles = 4
ENT.ParticleSize = 6
ENT.ParticleRadius = 5
ENT.PosParticles = { Vector(-6, -12, -19), Vector(-6, 12, -19), Vector(9, 12, -19), Vector(9, -12, -19) }

ENT.SoundName = "hl1/ambience/alien_minddrill.wav"
ENT.PropellersPitch = 255

ENT.UseAmmo = false

function ENT:Initialize()
	self:_Initialize("models/props_phx/construct/metal_plate1.mdl", 10000)

	if CLIENT then
		self:SetElements({
			["m+++++++"] = { type = "Model", model = "models/props_combine/combine_binocular01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-10, -10, -0.519), angle = Angle(-90, -45, 0), size = Vector(1.47, 1.47, 0.783), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_grate01a", skin = 0, bodygroup = {} },
			["l1+++"] = { type = "Model", model = "models/lamps/torch.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-22.048, -21.827, 0.964), angle = Angle(-90, 135, 0), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_grate01a", skin = 0, bodygroup = {} },
			["m++++"] = { type = "Model", model = "models/props_c17/pulleywheels_large01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, -0.5), angle = Angle(0, 90, 0), size = Vector(0.713, 0.713, 0.713), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_grate01a", skin = 0, bodygroup = {} },
			["l1+"] = { type = "Model", model = "models/lamps/torch.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-21.727, 21.947, 0.964), angle = Angle(-90, -135, 0), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_grate01a", skin = 0, bodygroup = {} },
			["m++++++++"] = { type = "Model", model = "models/props_combine/combine_binocular01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(10, -10, -0.519), angle = Angle(-90, -135, 0), size = Vector(1.47, 1.47, 0.783), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_grate01a", skin = 0, bodygroup = {} },
			["m"] = { type = "Model", model = "models/props_combine/combine_train02a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, 3.808), angle = Angle(180, 90, 180), size = Vector(0.179, 0.074, 0.064), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_grate01a", skin = 0, bodygroup = {} },
			["m+++++"] = { type = "Model", model = "models/props_combine/combine_binocular01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(10, 10, -0.519), angle = Angle(-90, 135, 0), size = Vector(1.47, 1.47, 0.783), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_grate01a", skin = 0, bodygroup = {} },
			["l12+++"] = { type = "Model", model = "models/lamps/torch.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(8.48, -10.865, -15.261), angle = Angle(-115.639, -90, 0), size = Vector(1.093, 1.093, 1.093), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_tower01a", skin = 0, bodygroup = {} },
			["l1++"] = { type = "Model", model = "models/lamps/torch.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(21.94, -22.147, 0.964), angle = Angle(-90, 45, 0), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_grate01a", skin = 0, bodygroup = {} },
			["ele"] = { type = "Model", model = "models/Mechanics/robotics/stand.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, -17.476), angle = Angle(0, 90, 0), size = Vector(0.074, 0.319, 0.072), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_grate01a", skin = 0, bodygroup = {} },
			["l12++"] = { type = "Model", model = "models/lamps/torch.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-5.768, -10.865, -15.261), angle = Angle(-115.639, -90, 0), size = Vector(1.093, 1.093, 1.093), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_tower01a", skin = 0, bodygroup = {} },
			["l12+"] = { type = "Model", model = "models/lamps/torch.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(8.21, 10.864, -15.261), angle = Angle(-115.639, 90, 0), size = Vector(1.093, 1.093, 1.093), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_tower01a", skin = 0, bodygroup = {} },
			["l1"] = { type = "Model", model = "models/lamps/torch.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(21.94, 21.871, 0.964), angle = Angle(-90, -45, 0), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_grate01a", skin = 0, bodygroup = {} },
			["element_name"] = { type = "Model", model = "models/props_combine/combine_train02a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, -10.565), angle = Angle(-180, -90, 0), size = Vector(0.21, 0.063, 0.05), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_grate01a", skin = 0, bodygroup = {} },
			["m++++++"] = { type = "Model", model = "models/props_combine/combine_binocular01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-10, 10, -0.519), angle = Angle(-90, 45, 0), size = Vector(1.47, 1.47, 0.783), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_grate01a", skin = 0, bodygroup = {} },
			["l12"] = { type = "Model", model = "models/lamps/torch.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-5.768, 10.864, -15.261), angle = Angle(-115.639, 90, 0), size = Vector(1.093, 1.093, 1.093), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_tower01a", skin = 0, bodygroup = {} },
			["m++"] = { type = "Model", model = "models/props_combine/combine_booth_short01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(2.684, 0, -0.058), angle = Angle(-90, 0, 0), size = Vector(0.2, 0.2, 0.2), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_grate01a", skin = 0, bodygroup = {} },
			["m+++"] = { type = "Model", model = "models/props_combine/combine_booth_short01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-0.519, 0, 0), angle = Angle(-90, 180, 0), size = Vector(0.2, 0.2, 0.2), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_grate01a", skin = 0, bodygroup = {} }
		})
	
		return
	end
end

function ENT:OnDestroyed() 
	constraint.RemoveConstraints(self, "Rope")
	self.hookedEntity = NULL
end

ENT.hookedEntity = NULL
ENT.nextshoot = 0
function ENT:Think()
	self:_Think()

	if CLIENT then
		return 
	end

	local user = self:GetDriver()

	if self:HasFuel() then	
		if user:IsValid() then
			if user:KeyDown(IN_ATTACK) and CurTime() > self.nextshoot then
				if self.hookedEntity:IsValid() then
					constraint.RemoveConstraints(self, "Rope")
					self.hookedEntity = NULL
				else
					local tr = util.TraceHull({
						start = self:GetPos(),
						endpos = self:GetPos() + Vector(0, 0, -300),
						filter = self,
						mins = Vector(-20, -20, 0),
						maxs = Vector(20, 20, 0)
					})

					local ent = tr.Entity
					if ent:IsValid() and ent:GetPhysicsObject():IsValid() then
						local corner = ent:OBBMins()
						constraint.Rope(self, ent, 0, 0, Vector(0, 0, 0), corner, (self:GetPos() - ent:GetPos() - corner):Length(), 0, 0, 0, "cable/cable2", false)

						corner.y = -corner.y
						constraint.Rope(self, ent, 0, 0, Vector(0, 0, 0), corner, (self:GetPos() - ent:GetPos() - corner):Length(),	0, 0, 0, "cable/cable2", false)


						local corner = ent:OBBMaxs()
						constraint.Rope(self, ent, 0, 0, Vector(0, 0, 0), corner, (self:GetPos() - ent:GetPos() - corner):Length(),	0, 0, 0, "cable/cable2", false)
						
						corner.y = -corner.y
						constraint.Rope(self, ent, 0, 0, Vector(0, 0, 0), corner, (self:GetPos() - ent:GetPos() - corner):Length(),	0, 0, 0, "cable/cable2", false)


						self.hookedEntity = ent
					end
				end

				self.nextshoot = CurTime() + 0.3
			end
		end

		if self.hookedEntity:IsValid() then
			local len = (self.hookedEntity:OBBMaxs() - self.hookedEntity:OBBCenter()):Length() * 0.6

			for i = 1, 6 do
				local ef = EffectData()
				ef:SetStart(Vector(0, 0, 0))
				ef:SetOrigin(self.hookedEntity:GetPos() + Vector(math.cos(i) * len, math.sin(i) * len, 0))
				ef:SetEntity(self)
				ef:SetAngles(Angle(0, 0, 255))
				util.Effect("effect_dr2_beam", ef)
			end
		end
	end

	self:NextThink(CurTime())
	return true
end