AddCSLuaFile()

ENT.Base = "drone_two_entity"
ENT.PrintName		= "Cargo Drone Mark III"
ENT.Category        = "Drones 2: Support" 
ENT.AdminOnly = true
ENT.Spawnable = true

ENT.Speed = 650
ENT.armor = 600

ENT.forward = 100
ENT.up = 30
ENT.cam_up = 18
ENT.cam_forward = 12

ENT.Noise = false

ENT.Mark = 3
ENT.shouldConsumeFuel = false

ENT.EnableParticles = true
ENT.NumParticles = 4
ENT.ParticleSize = 6
ENT.ParticleRadius = 5
ENT.PosParticles = { Vector(-20, -22, -19), Vector(-20, 22, -19), Vector(20, 22, -19), Vector(20, -22, -19) }

ENT.UseAmmo = false

ENT.SoundName = "hl1/ambience/alien_minddrill.wav"
ENT.PropellersPitch = 255

function ENT:Initialize()
	self:_Initialize("models/props_phx/construct/metal_plate1.mdl", 10000)

	if CLIENT then
		self:SetElements({
			["m+"] = { type = "Model", model = "models/props_combine/combine_train02a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, -10, 0), angle = Angle(0, 90, 180), size = Vector(0.1, 0.079, 0.1), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_grate01a", skin = 0, bodygroup = {} },
			["cvwpan"] = { type = "Model", model = "models/hunter/plates/plate1x2.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(22.416, 0, -4.179), angle = Angle(69.307, 0, 0), size = Vector(0.192, 0.192, 0.192), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_grate01a", skin = 0, bodygroup = {} },
			["m2"] = { type = "Model", model = "models/props_phx/construct/metal_plate_curve360.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, -18.182), angle = Angle(0, 0, 0), size = Vector(0.204, 0.204, 0.204), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001", skin = 0, bodygroup = {} },
			["la1+"] = { type = "Model", model = "models/lamps/torch.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 18.885, -4.706), angle = Angle(-90, 90, 0), size = Vector(0.875, 3.204, 0.875), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001", skin = 0, bodygroup = {} },
			["la1"] = { type = "Model", model = "models/lamps/torch.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, -18.886, -4.706), angle = Angle(-90, -90, 0), size = Vector(0.875, 3.204, 0.875), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001", skin = 0, bodygroup = {} },
			["m2++++++++++++"] = { type = "Model", model = "models/props_lab/teleplatform.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(9.869, 0, -0.519), angle = Angle(180, 0, 0), size = Vector(0.3, 0.56, 0.25), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_booth_tall01a", skin = 0, bodygroup = {} },
			["m2++++++++"] = { type = "Model", model = "models/props_combine/combine_emitter01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(12, 12, -0.519), angle = Angle(0, 0, 90), size = Vector(0.8, 0.8, 0.8), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["la2+"] = { type = "Model", model = "models/hunter/misc/shell2x2a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-20.543, -22.244, -22.071), angle = Angle(0, 0, 0), size = Vector(0.159, 0.159, 0.159), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001", skin = 0, bodygroup = {} },
			["m2+++++"] = { type = "Model", model = "models/props_combine/headcrabcannister01a_skybox.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(4.675, 9.869, -14.027), angle = Angle(0, 180, 0), size = Vector(2.118, 2.118, 2.118), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["la2"] = { type = "Model", model = "models/hunter/misc/shell2x2a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(20.462, -22.244, -22.071), angle = Angle(0, 0, 0), size = Vector(0.159, 0.159, 0.159), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001", skin = 0, bodygroup = {} },
			["m+++"] = { type = "Model", model = "models/props_combine/combine_booth_short01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-0.519, 0, 0), angle = Angle(-90, 180, 0), size = Vector(0.2, 0.2, 0.2), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_grate01a", skin = 0, bodygroup = {} },
			["m+++++++++"] = { type = "Model", model = "models/props_combine/combine_booth_short01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(9.918, 0, 0), angle = Angle(90, 0, 0), size = Vector(0.2, 0.2, 0.335), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_grate01a", skin = 0, bodygroup = {} },
			["m2+++++++++"] = { type = "Model", model = "models/props_combine/combine_emitter01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-12, 12, -0.519), angle = Angle(180, 0, 90), size = Vector(0.8, 0.8, 0.8), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m2+++"] = { type = "Model", model = "models/props_combine/headcrabcannister01a_skybox.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-4.676, 9.869, -14.027), angle = Angle(0, 0, 0), size = Vector(2.118, 2.118, 2.118), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m2++++++++++"] = { type = "Model", model = "models/props_combine/combine_emitter01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(12, -12, -0.519), angle = Angle(0, 0, -90), size = Vector(0.8, 0.8, 0.8), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m++++"] = { type = "Model", model = "models/props_combine/combine_booth_short01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-9.919, 0, 0), angle = Angle(90, 180, 0), size = Vector(0.2, 0.2, 0.335), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_grate01a", skin = 0, bodygroup = {} },
			["m2+++++++"] = { type = "Model", model = "models/props_combine/combine_mortar01b.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, -20.261), angle = Angle(0, 180, 0), size = Vector(0.301, 0.301, 0.301), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m2+++++++++++++"] = { type = "Model", model = "models/props_lab/teleplatform.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-9.87, 0, -0.519), angle = Angle(180, 180, 0), size = Vector(0.3, 0.56, 0.25), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_booth_tall01a", skin = 0, bodygroup = {} },
			["m2+++++++++++"] = { type = "Model", model = "models/props_combine/combine_emitter01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-12, -12, -0.519), angle = Angle(180, 0, -90), size = Vector(0.8, 0.8, 0.8), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m2++++++++++++++++"] = { type = "Model", model = "models/props_lab/keypad.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-12.988, 0, -12.988), angle = Angle(-90, 90, 0), size = Vector(1.47, 1.47, 1.47), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_booth_tall01a", skin = 0, bodygroup = {} },
			["m"] = { type = "Model", model = "models/props_combine/combine_train02a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 10, 0), angle = Angle(0, 90, 180), size = Vector(0.1, 0.079, 0.1), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_grate01a", skin = 0, bodygroup = {} },
			["m2++++++++++++++"] = { type = "Model", model = "models/props_lab/keypad.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(12.987, 0, -12.988), angle = Angle(-90, 90, 0), size = Vector(1.47, 1.47, 1.47), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_booth_tall01a", skin = 0, bodygroup = {} },
			["m2++"] = { type = "Model", model = "models/mechanics/roboticslarge/claw_hub_8.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, -14.027), angle = Angle(0, 0, 0), size = Vector(0.159, 0.159, 0.159), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/masterinterface_disp", skin = 0, bodygroup = {} },
			["cvwpan+"] = { type = "Model", model = "models/hunter/plates/plate1x2.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-22.417, 0, -4.179), angle = Angle(-69.308, 0, 0), size = Vector(0.192, 0.192, 0.192), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_grate01a", skin = 0, bodygroup = {} },
			["la2++"] = { type = "Model", model = "models/hunter/misc/shell2x2a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-20.543, 23.395, -22.071), angle = Angle(0, 0, 0), size = Vector(0.159, 0.159, 0.159), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001", skin = 0, bodygroup = {} },
			["m2+"] = { type = "Model", model = "models/props_phx/construct/metal_angle360.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, -16.105), angle = Angle(0, 0, 0), size = Vector(0.2, 0.2, 0.2), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["cv"] = { type = "Model", model = "models/props_lab/tpplug.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, 12.47), angle = Angle(90, 0, 0), size = Vector(0.5, 2.315, 1.031), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_grate01a", skin = 0, bodygroup = {} },
			["m2++++++++++++++++++"] = { type = "Model", model = "models/props_lab/teleplatform.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 12, -0.519), angle = Angle(180, -90, 0), size = Vector(0.3, 0.56, 0.25), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_booth_tall01a", skin = 0, bodygroup = {} },
			["m2++++++"] = { type = "Model", model = "models/props_combine/headcrabcannister01a_skybox.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(4.675, -9.87, -14.027), angle = Angle(0, 180, 0), size = Vector(2.118, 2.118, 2.118), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["la2+++"] = { type = "Model", model = "models/hunter/misc/shell2x2a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(20.462, 22.472, -22.071), angle = Angle(0, 0, 0), size = Vector(0.159, 0.159, 0.159), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001", skin = 0, bodygroup = {} },
			["m2++++"] = { type = "Model", model = "models/props_combine/headcrabcannister01a_skybox.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-4.676, -9.87, -14.027), angle = Angle(0, 0, 0), size = Vector(2.118, 2.118, 2.118), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["cvw"] = { type = "Model", model = "models/props_interiors/VendingMachineSoda01a_door.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, -12.695), angle = Angle(-90, 0, 0), size = Vector(0.338, 0.358, 0.384), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_grate01a", skin = 0, bodygroup = {} },
			["m2+++++++++++++++++"] = { type = "Model", model = "models/props_lab/teleplatform.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, -12, -0.519), angle = Angle(180, 90, 0), size = Vector(0.3, 0.56, 0.25), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_booth_tall01a", skin = 0, bodygroup = {} },
			["m++"] = { type = "Model", model = "models/props_combine/combine_booth_short01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, 0), angle = Angle(-90, 0, 0), size = Vector(0.2, 0.2, 0.2), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_grate01a", skin = 0, bodygroup = {} },
			["m2+++++++++++++++"] = { type = "Model", model = "models/props_lab/keypad.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-12.988, 0, -12.988), angle = Angle(-90, 90, 0), size = Vector(1.47, 1.47, 1.47), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_booth_tall01a", skin = 0, bodygroup = {} }
		})
	
		return
	end
end

function ENT:OnDestroyed() 
	constraint.RemoveConstraints(self, "Rope")
	self.hookedEntity = NULL
end

ENT.hookedEntity = NULL
ENT.nextshoot = 0
function ENT:Think()
	self:_Think()

	if CLIENT then
		return 
	end

	local user = self:GetDriver()

	if self:HasFuel() then	
		if user:IsValid() then
			if user:KeyDown(IN_ATTACK) and CurTime() > self.nextshoot then
				if self.hookedEntity:IsValid() then
					constraint.RemoveConstraints(self, "Rope")
					self.hookedEntity = NULL
				else
					local tr = util.TraceHull({
						start = self:GetPos(),
						endpos = self:GetPos() + Vector(0, 0, -350),
						filter = self,
						mins = Vector(-22, -22, 0),
						maxs = Vector(22, 22, 0)
					})

					local ent = tr.Entity
					if ent:IsValid() and ent:GetPhysicsObject():IsValid() then
						local corner = ent:OBBMins()
						constraint.Rope(self, ent, 0, 0, Vector(0, 0, 0), corner, (self:GetPos() - ent:GetPos() - corner):Length(), 0, 0, 0, "cable/cable2", false)

						corner.y = -corner.y
						constraint.Rope(self, ent, 0, 0, Vector(0, 0, 0), corner, (self:GetPos() - ent:GetPos() - corner):Length(),	0, 0, 0, "cable/cable2", false)


						local corner = ent:OBBMaxs()
						constraint.Rope(self, ent, 0, 0, Vector(0, 0, 0), corner, (self:GetPos() - ent:GetPos() - corner):Length(),	0, 0, 0, "cable/cable2", false)
						
						corner.y = -corner.y
						constraint.Rope(self, ent, 0, 0, Vector(0, 0, 0), corner, (self:GetPos() - ent:GetPos() - corner):Length(),	0, 0, 0, "cable/cable2", false)


						self.hookedEntity = ent
					end
				end

				self.nextshoot = CurTime() + 0.3
			end
		end

		if self.hookedEntity:IsValid() then
			local len = (self.hookedEntity:OBBMaxs() - self.hookedEntity:OBBCenter()):Length() * 0.6

			for i = 1, 16 do
				local ef = EffectData()
				ef:SetStart(Vector(0, 0, 0))
				ef:SetOrigin(self.hookedEntity:GetPos() + Vector(math.cos(i) * len, math.sin(i) * len, 0))
				ef:SetEntity(self)
				ef:SetAngles(Angle(0, 0, 255))
				util.Effect("effect_dr2_beam", ef)
			end
		end
	end

	self:NextThink(CurTime())
	return true
end