AddCSLuaFile()

ENT.Base = "drone_two_entity"
ENT.PrintName		= "Civilian Drone"
ENT.Category        = "Drones 2: Misc"
ENT.Spawnable = true

ENT.Speed = 700
ENT.armor = 25

ENT.forward = 30
ENT.up = -2
ENT.cam_up = 4

ENT.MaxFuel = 25
ENT.PropellersPitch = 240
ENT.Noise = false
ENT.UseNightVision = false

ENT.DrawEffects = false
ENT.DrawHUD = false
ENT.CustomHUD = function(drone, x, y)
	--Fuel
	surface.SetDrawColor(Color(0, 150, 255, 255))
	surface.DrawOutlinedRect(x - 100, y - 80, 200, 15)
	surface.DrawRect(x - 95, y - 75, drone.Fuel / drone.MaxFuel * 190, 5)
	draw.SimpleText("Fuel " .. math.floor(drone.Fuel / drone.MaxFuel * 100) .. "%", "Trebuchet24", x - 115, y - 85, Color(0, 255, 255), TEXT_ALIGN_RIGHT)
end

function ENT:Initialize()
	self:_Initialize("models/props_phx/construct/metal_plate1.mdl", 100)

	if CLIENT then
		self:SetElements({
			["palk+"] = { type = "Model", model = "models/mechanics/solid_steel/type_a_2_4.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, -0.24), angle = Angle(0, -45, 0), size = Vector(0.727, 0.279, 0.119), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["palk"] = { type = "Model", model = "models/mechanics/solid_steel/type_a_2_4.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, -0.24), angle = Angle(0, 45, 0), size = Vector(0.727, 0.279, 0.119), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["m6"] = { type = "Model", model = "models/hunter/plates/plate1x1.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(12.3, -12.355, -0.452), angle = Angle(0, 0, 0), size = Vector(0.323, 0.323, 0.009), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/airboat/airboat_blur02", skin = 0, bodygroup = {} },
			["m6+"] = { type = "Model", model = "models/hunter/plates/plate1x1.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-12.301, -12.355, -0.452), angle = Angle(0, 0, 0), size = Vector(0.323, 0.323, 0.009), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/airboat/airboat_blur02", skin = 0, bodygroup = {} },
			["base"] = { type = "Model", model = "models/XQM/coastertrain2seat.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, 0), angle = Angle(0, 0, 180), size = Vector(0.096, 0.096, 0.096), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["m6++"] = { type = "Model", model = "models/hunter/plates/plate1x1.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(12.3, 12.354, -0.452), angle = Angle(0, 0, 0), size = Vector(0.323, 0.323, 0.009), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/airboat/airboat_blur02", skin = 0, bodygroup = {} },
			["base+"] = { type = "Model", model = "models/XQM/coastertrain2seat.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, -0.083, -0.32), angle = Angle(0, 0, 0), size = Vector(0.096, 0.096, 0.096), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001", skin = 0, bodygroup = {} },
			["m6+++"] = { type = "Model", model = "models/hunter/plates/plate1x1.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-12.301, 12.354, -0.452), angle = Angle(0, 0, 0), size = Vector(0.323, 0.323, 0.009), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/airboat/airboat_blur02", skin = 0, bodygroup = {} }
		})
	
		return
	end
end

function ENT:OnDestroyed() end
function ENT:Think()
	self:_Think()

	if CLIENT then
		if self:HasFuel() and not self:IsDroneDestroyed() then
			self.WElements["m6"].angle = Angle(0, CurTime() * 1500, 0)
			self.WElements["m6+"].angle = Angle(0, CurTime() * 1500, 0)
			self.WElements["m6++"].angle = Angle(0, CurTime() * 1500, 0)
			self.WElements["m6+++"].angle = Angle(0, CurTime() * 1500, 0)
		end

		return 
	end

	self:NextThink(CurTime())
	return true
end
