AddCSLuaFile()

ENT.Base = "drone_two_entity"
ENT.PrintName		= "Heavy Drone Mark II"
ENT.Category        = "Drones 2: Heavy"
ENT.Spawnable = true

ENT.Speed = 400
ENT.armor = 700

ENT.forward = 60
ENT.up = 5
ENT.cam_up = 13

ENT.Noise = false
ENT.Mark = 2

ENT.EnableParticles = true
ENT.NumParticles = 4
ENT.ParticleSize = 6
ENT.ParticleRadius = 5
ENT.PosParticles = { Vector(-20, -20, -2), Vector(-20, 20, -2), Vector(20, 20, -2), Vector(20, -20, -2) }

ENT.Ammo2 = 20
ENT.MaxAmmo2 = 20
ENT.AmmoBox2 = 1
ENT.AmmoType2 = "item_rpg_round"
ENT.UseAmmo2 = true

ENT.SoundName = "hl1/ambience/alien_minddrill.wav"
ENT.PropellersPitch = 255

function ENT:Initialize()
	self:_Initialize("models/props_phx/construct/metal_plate1.mdl", 700)

	if CLIENT then
		self:SetElements({
			["m+"] = { type = "Model", model = "models/props_combine/combine_mine01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, -7.5), angle = Angle(0, 0, 0), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m"] = { type = "Model", model = "models/props_combine/breentp_rings.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, 0), angle = Angle(0, 0, 0), size = Vector(0.1, 0.1, 0.1), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m+++++"] = { type = "Model", model = "models/props_combine/combine_light001a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-5, -5, 0), angle = Angle(90, -45, 0), size = Vector(0.56, 0.56, 0.56), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m++++++++++"] = { type = "Model", model = "models/props_combine/combine_binocular01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-4.301, 4.3, -4.401), angle = Angle(111, -135, 0), size = Vector(0.3, 0.4, 0.349), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m+++++++"] = { type = "Model", model = "models/props_combine/combine_light001a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(5, -5, 0), angle = Angle(90, -135, 0), size = Vector(0.56, 0.56, 0.56), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m++++++"] = { type = "Model", model = "models/props_combine/combine_light001a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(5, 5, 0), angle = Angle(90, 135, 0), size = Vector(0.56, 0.56, 0.56), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m+++++++++"] = { type = "Model", model = "models/props_combine/combine_binocular01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(4.3, 4.3, -4.401), angle = Angle(111, -45, 0), size = Vector(0.3, 0.4, 0.349), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m+++++++++++"] = { type = "Model", model = "models/props_combine/combine_binocular01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-4.301, -4.301, -4.401), angle = Angle(111, 135, 0), size = Vector(0.3, 0.4, 0.349), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m++++++++"] = { type = "Model", model = "models/props_combine/combine_binocular01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(4.3, -4.301, -4.401), angle = Angle(111, 45, 0), size = Vector(0.3, 0.4, 0.349), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m++++"] = { type = "Model", model = "models/props_combine/combine_light001a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-5, -5, 0), angle = Angle(90, -45, 0), size = Vector(0.56, 0.56, 0.56), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m++++++++++++++++"] = { type = "Model", model = "models/props_combine/combine_mine01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, 5.053), angle = Angle(0, 6.098, 0), size = Vector(0.5, 0.5, 0.367), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m++"] = { type = "Model", model = "models/props_combine/combine_mine01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, 5.453), angle = Angle(180, 15, 0), size = Vector(0.5, 0.5, 0.433), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m+++"] = { type = "Model", model = "models/props_combine/combine_light001a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-5, 5, 0), angle = Angle(90, 45, 0), size = Vector(0.56, 0.56, 0.56), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} }
		})
	
		return
	end

	self.gun = ents.Create("minigun_dr2ent")
	self.gun:SetPos(self:GetPos() + self:GetForward() * -2 + self:GetUp() * -5 + self:GetRight() * 5)
	self.gun:SetAngles(self:GetAngles())
	self.gun:Spawn()
	self.gun:SetSolid(SOLID_NONE)
	self.gun:SetParent(self)
	self.gun._Think = function()
		local user = self:GetDriver()

		if not self:IsDroneDestroyed() and self:HasFuel() and user:IsValid() then		
			if user:KeyDown(IN_ATTACK) and self:HasAmmo() then
				self.gun:Switch(true)

				if CurTime() > self.nextshoot then
					local bullet = {}
					bullet.Num = 1
					bullet.Src = self.gun:GetPos() + self.gun:GetForward() * 20
					bullet.Dir = self:GetDriverDirection()
					bullet.Spread = Vector(0.01, 0.01, 0.01)
					bullet.Tracer = 2	
					bullet.Force = 50
					bullet.Damage = 4
					bullet.Attacker = self.Owner
					 
					user:EmitSound("weapons/pistol/pistol_fire2.wav", 100, math.random(200, 250))

					self:SetAmmo(self.Ammo - 1)
					self.gun:FireBullets(bullet)

					self.nextshoot = CurTime() + 0.01
				end
			else
				self.gun:Switch(false)
			end

			self.gun:SetAngles(self:GetAngles() + Angle(user:EyeAngles().p < 0 and 0 or user:EyeAngles().p, user:EyeAngles().y, 0))
		else
			self.gun:Switch(false)
		end
	end

	self.nextshoot2 = 0
	self.gun2 = ents.Create("rocketgun_d2ent")
	self.gun2:SetPos(self:GetPos() + self:GetForward() * -2 + self:GetUp() * -5 + self:GetRight() * -5)
	self.gun2:SetAngles(self:GetAngles())
	self.gun2:Spawn()
	self.gun2:SetSolid(SOLID_NONE)
	self.gun2:SetParent(self)
	self.gun2._Think = function()
		local user = self:GetDriver()

		if not self:IsDroneDestroyed() and self:HasFuel() and user:IsValid() then
			if user:KeyDown(IN_ATTACK2) and self:HasAmmo2() then
				if CurTime() > self.nextshoot2 then
					local ammo = ents.Create("rocket_dent")
					ammo:SetPos(self.gun2:GetPos())
					ammo:SetOwner(self.Owner)
					ammo:SetAngles(self.gun2:GetAngles())
					ammo:Spawn()
				
					self.gun2:EmitSound("weapons/rpg/rocketfire1.wav")
				
					local physamm = ammo:GetPhysicsObject()
					if IsValid(physamm) then physamm:EnableGravity(false) end 
				
					physamm:AddVelocity(self:GetDriverDirection() * 5000)

					self:SetAmmo2(self.Ammo2 - 1)

					self.nextshoot2 = CurTime() + 1.5
				end
			end

			self.gun2:SetAngles(self:GetAngles() + Angle(user:EyeAngles().p < 0 and 0 or user:EyeAngles().p, user:EyeAngles().y, 0))
		end
	end
end

function ENT:Think()
	self:_Think()

	if CLIENT then
		return 
	end

	if self.gun:IsValid() then self.gun._Think() end
	if self.gun2:IsValid() then self.gun2._Think() end

	self:NextThink(CurTime())
	return true
end