AddCSLuaFile()

ENT.Base = "drone_two_entity"
ENT.PrintName		= "Heavy Drone Mark III"
ENT.Category        = "Drones 2: Heavy"
ENT.AdminOnly = true
ENT.Spawnable = true

ENT.Speed = 600
ENT.armor = 800

ENT.forward = 60
ENT.up = 5
ENT.cam_up = 18

ENT.Noise = false
ENT.shouldConsumeFuel = false
ENT.Mark = 3

ENT.EnableParticles = true
ENT.NumParticles = 3
ENT.ParticleSize = 6
ENT.ParticleRadius = 8
ENT.PosParticles = { Vector(-11, -20, -2), Vector(-11, 20, -2), Vector(18, 0, -2) }

ENT.Ammo2 = 40
ENT.MaxAmmo2 = 40
ENT.AmmoBox2 = 1
ENT.AmmoType2 = "item_rpg_round"
ENT.UseAmmo2 = true

ENT.SoundName = "hl1/ambience/alien_minddrill.wav"
ENT.PropellersPitch = 255

function ENT:Initialize()
	self:_Initialize("models/props_phx/construct/metal_plate1.mdl",800)

	if CLIENT then
		self:SetElements({
			["m+"] = { type = "Model", model = "models/props_combine/combine_mine01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, -9.796), angle = Angle(0, -36.716, 0), size = Vector(0.725, 0.725, 0.725), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			--["hell+"] = { type = "Sprite", sprite = "sprites/redglow3", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(4.32, -8.506, -18.095), size = { x = 3.952, y = 3.952 }, color = Color(255, 255, 255, 255), nocull = true, additive = true, vertexalpha = true, vertexcolor = true, ignorez = false},
			["assh+++"] = { type = "Model", model = "models/props_combine/headcrabcannister01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(4.389, 8.168, -15.726), angle = Angle(90, 0, -4.983), size = Vector(0.039, 0.15, 0.15), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m++++"] = { type = "Model", model = "models/props_combine/combine_light001a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-3.332, -6.542, -1.208), angle = Angle(90, -60, 0), size = Vector(0.899, 0.899, 0.899), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m++++++++++++++++"] = { type = "Model", model = "models/props_combine/combine_mine01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, 5.127), angle = Angle(0, -32.927, 0), size = Vector(0.725, 0.725, 0.725), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			--["hell"] = { type = "Sprite", sprite = "sprites/redglow3", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-9.525, 0, -18.095), size = { x = 3.952, y = 3.952 }, color = Color(255, 255, 255, 255), nocull = true, additive = true, vertexalpha = true, vertexcolor = true, ignorez = false},
			---["hell++"] = { type = "Sprite", sprite = "sprites/redglow3", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(4.677, 8.19, -18.095), size = { x = 3.952, y = 3.952 }, color = Color(255, 255, 255, 255), nocull = true, additive = true, vertexalpha = true, vertexcolor = true, ignorez = false},
			["m++++++++++++"] = { type = "Model", model = "models/props_combine/combine_binocular01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-5.164, 7.933, -7.404), angle = Angle(94.027, -119.469, 0), size = Vector(0.501, 0.501, 0.501), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m"] = { type = "Model", model = "models/props_combine/breentp_rings.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, 0), angle = Angle(0, 0, 0), size = Vector(0.15, 0.15, 0.15), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m+++++"] = { type = "Model", model = "models/props_combine/combine_light001a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-4.193, 6.788, -1.208), angle = Angle(90, 60, 0), size = Vector(0.899, 0.899, 0.899), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["prot+"] = { type = "Model", model = "models/props_combine/combine_barricade_med02a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-7.527, -0.257, -5.756), angle = Angle(0, -180, 0), size = Vector(0.13, 0.13, 0.15), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m++"] = { type = "Model", model = "models/props_combine/combine_mine01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, 9.352), angle = Angle(180, -32.927, 0), size = Vector(0.725, 0.725, 0.725), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["assh+++++"] = { type = "Model", model = "models/props_combine/headcrabcannister01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-9.757, 0, -15.726), angle = Angle(90, 0, -6.179), size = Vector(0.039, 0.15, 0.15), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["moln"] = { type = "Model", model = "models/props_junk/PopCan01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, 14.732), angle = Angle(0, 0, 0), size = Vector(0.416, 0.416, 1.378), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/alyx/emptool_glow", skin = 0, bodygroup = {} },
			["assh"] = { type = "Model", model = "models/props_combine/combine_mortar01b.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, 2.316), angle = Angle(0, 0, 0), size = Vector(0.282, 0.282, 0.344), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["prot++"] = { type = "Model", model = "models/props_combine/combine_barricade_med02a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(3.914, -6.268, -5.756), angle = Angle(0, 58.291, 0), size = Vector(0.13, 0.13, 0.15), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["assh++++"] = { type = "Model", model = "models/props_combine/headcrabcannister01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(4.15, -8.428, -15.726), angle = Angle(90, 0, 1.133), size = Vector(0.039, 0.15, 0.15), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m+++++++++++"] = { type = "Model", model = "models/props_combine/combine_binocular01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-4.401, -8.353, -7.404), angle = Angle(94.027, 119.456, 0), size = Vector(0.501, 0.501, 0.501), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m+++++++++++++"] = { type = "Model", model = "models/props_combine/combine_binocular01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(9.26, 0.074, -7.404), angle = Angle(94.027, 0.347, 0), size = Vector(0.501, 0.501, 0.501), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["prot"] = { type = "Model", model = "models/props_combine/combine_barricade_med02a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(3.644, 7.125, -5.756), angle = Angle(0, -63.752, 0), size = Vector(0.13, 0.13, 0.15), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m+++"] = { type = "Model", model = "models/props_combine/combine_light001a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(8.227, 0.14, -1.208), angle = Angle(90, -180, 0), size = Vector(0.899, 0.899, 0.899), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} }
		})
	
		return
	end

	self.gun = ents.Create("minigun_dr2ent")
	self.gun:SetPos(self:GetPos() + self:GetForward() * -20 + self:GetUp() * -10 + self:GetRight() * 32)
	self.gun:SetAngles(self:GetAngles())
	self.gun:Spawn()
	self.gun:SetSolid(SOLID_NONE)
	self.gun:SetParent(self)
	self.gun._Think = function()
		local user = self:GetDriver()

		if not self:IsDroneDestroyed() and self:HasFuel() and user:IsValid() then
			if user:KeyDown(IN_ATTACK) and self:HasAmmo() then
				self.gun:Switch(true)

				if CurTime() > self.nextshoot then
					local bullet = {}
					bullet.Num = 1
					bullet.Src = self.gun:GetPos() + self.gun:GetForward() * 20
					bullet.Dir = self:GetDriverDirection()
					bullet.Spread = Vector(0.03, 0.03, 0.03)
					bullet.Tracer = 2	
					bullet.Force = 50
					bullet.Damage = 6
					bullet.Attacker = self.Owner
					 
					user:EmitSound("weapons/pistol/pistol_fire2.wav", 100, math.random(200, 250))

					self:SetAmmo(self.Ammo - 1)
					self.gun:FireBullets(bullet)

					self.nextshoot = CurTime() + 0.01
				end
			else
				self.gun:Switch(false)
			end

			self.gun:SetAngles(self:GetAngles() + Angle(user:EyeAngles().p < 0 and 0 or user:EyeAngles().p, user:EyeAngles().y, 0))
		else
			self.gun:Switch(false)
		end
	end

	self.nextshoot2 = 0
	self.gun2 = ents.Create("rocketgun_d2ent")
	self.gun2:SetPos(self:GetPos() + self:GetForward() * -20 + self:GetUp() * -10 + self:GetRight() * -32)
	self.gun2:SetAngles(self:GetAngles())
	self.gun2:Spawn()
	self.gun2:SetSolid(SOLID_NONE)
	self.gun2:SetParent(self)
	self.gun2._Think = function()
		local user = self:GetDriver()

		if not self:IsDroneDestroyed() and self:HasFuel() and user:IsValid() then		
			if user:KeyDown(IN_ATTACK2) and self:HasAmmo2() then
				if CurTime() > self.nextshoot2 then
					local ammo = ents.Create("rocket_dent")
					ammo:SetPos(self.gun2:GetPos())
					ammo:SetOwner(self.Owner)
					ammo:SetAngles(self.gun2:GetAngles())
					ammo:Spawn()
				
					self.gun2:EmitSound("weapons/rpg/rocketfire1.wav")
				
					local physamm = ammo:GetPhysicsObject()
					if IsValid(physamm) then physamm:EnableGravity(false) end 
				
					physamm:AddVelocity(self:GetDriverDirection() * 5000)

					self:SetAmmo2(self.Ammo2 - 1)

					self.nextshoot2 = CurTime() + 1.5
				end
			end

			self.gun2:SetAngles(self:GetAngles() + Angle(user:EyeAngles().p < 0 and 0 or user:EyeAngles().p, user:EyeAngles().y, 0))
		end
	end

	self.gun3 = ents.Create("flamethrower_dent")
	self.gun3:SetPos(self:GetPos() + self:GetForward() * 32 + self:GetUp() * -10)
	self.gun3:SetAngles(self:GetAngles())
	self.gun3:Spawn()
	self.gun3:SetSolid(SOLID_NONE)
	self.gun3:SetParent(self)
	self.gun3._Think = function()
		local user = self:GetDriver()

		if self:WaterLevel() < 3 and not self:IsDroneDestroyed() and self:HasFuel() and user:IsValid() then	
			if user:KeyDown(IN_WALK) then
				if CurTime() > self.nextshoot2 then
					self.gun3:EmitSound( "ambient/machines/thumper_dust.wav", 46, 100 )
					
					local tr = self:GetAim()
					
					timer.Simple(self:GetPos():Distance(tr.HitPos)/800, function()
						if self:IsValid() and IsValid(tr.Entity) and self:GetDriver() != NULL then						
							if self:GetPos():Distance(tr.HitPos) < 1350 then
								local dmg = DamageInfo()
								dmg:SetAttacker(self:GetDriver())
								dmg:SetInflictor(self)
								dmg:SetDamage(1)
								dmg:SetDamageType(DMG_BURN)
								tr.Entity:TakeDamageInfo(dmg)
								tr.Entity:Ignite(10, 100)
							end
						end
					end)

	                local ef = EffectData()
	                ef:SetOrigin(tr.HitPos)
	                ef:SetStart(self.gun3:GetPos() + self.gun3:GetForward() * 17 + self.gun3:GetUp() * -1)  // + self:GetForward() * 35 + self:GetUp() * -10)
	                util.Effect("effect_dr2_flame", ef, true, true)

					self.nextshoot2 = CurTime() + 0.03
				end
			end

			self.gun3:SetAngles(self:GetAngles() + Angle(user:EyeAngles().p < 0 and 0 or user:EyeAngles().p, user:EyeAngles().y, 0))
		end
	end	
end

function ENT:Think()
	self:_Think()

	if CLIENT then
		return 
	end

	if self.gun:IsValid() then self.gun._Think() end
	if self.gun2:IsValid() then self.gun2._Think() end
	if self.gun3:IsValid() then self.gun3._Think() end

	self:NextThink(CurTime())
	return true
end