AddCSLuaFile()

ENT.Base = "drone_two_entity"
ENT.PrintName		= "Laser Drone Mark II"
ENT.Category        = "Drones 2: Light"
ENT.Spawnable = true

ENT.Speed = 600
ENT.armor = 200

ENT.forward = 60
ENT.up = 5
ENT.cam_up = 10

ENT.Noise = true
ENT.MaxFuel = 130
ENT.EnableSound = false

ENT.Mark = 2

ENT.UseAmmo = false

ENT.EnableParticles = true
ENT.NumParticles = 4
ENT.ParticleSize = 6
ENT.ParticleRadius = 5
ENT.PosParticles = { Vector(-34, -34, -1), Vector(-34, 34, -1), Vector(34, 34, -1), Vector(34, -34, -1) }
ENT.VelocityParticles = { Vector(-12, 12, 0), Vector(-12, -12, 0), Vector(12, -12, 0), Vector(12, 12, 0) }

function ENT:Initialize()
	self:_Initialize("models/props_phx/construct/metal_plate1.mdl", 200)

	if CLIENT then
		self:SetElements({
			["m++++++++"] = { type = "Model", model = "models/mechanics/roboticslarge/claw2l.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-20, -20, 0), angle = Angle(-110, -45, 90), size = Vector(0.1, 0.237, 0.107), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
			["light+"] = { type = "Model", model = "models/props_junk/PopCan01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0.936, 0, 1.411), angle = Angle(-180, 0, 0), size = Vector(0.819, 0.819, 0.819), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/masterinterface01c", skin = 0, bodygroup = {} },
			["m+++++"] = { type = "Model", model = "models/props_combine/combine_light001a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-15.065, 0, -1.558), angle = Angle(-90, 90, 90), size = Vector(0.625, 0.625, 0.625), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
			["light"] = { type = "Model", model = "models/props_junk/PopCan01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(6.877, 0, 1.411), angle = Angle(-180, 0, 0), size = Vector(0.819, 0.819, 0.819), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/masterinterface01c", skin = 0, bodygroup = {} },
			["m+++++++"] = { type = "Model", model = "models/mechanics/roboticslarge/claw2l.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-20, 20, 0), angle = Angle(-110, 45, 90), size = Vector(0.1, 0.237, 0.107), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
			["m+++++++++"] = { type = "Model", model = "models/props_combine/combine_mine01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, -2.597), angle = Angle(180, 0, 0), size = Vector(0.69, 0.69, 0.301), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
			["huevogrejutbatarei"] = { type = "Model", model = "models/props_interiors/radiator01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(12.102, -0.153, -0.331), angle = Angle(0, 0, 0), size = Vector(0.125, 0.189, 0.14), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
			["huevogrejutbatarei+"] = { type = "Model", model = "models/props_interiors/radiator01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(12.423, -0.153, 2.171), angle = Angle(0, 0, 0), size = Vector(0.059, 0.129, 0.035), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
			["sopl+++"] = { type = "Model", model = "models/Items/combine_rifle_ammo01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(31.308, 31.215, 2.321), angle = Angle(34.429, 0, 149.298), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
			["m++++++"] = { type = "Model", model = "models/mechanics/roboticslarge/claw2l.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(20, 20, 0), angle = Angle(-110, 135, 90), size = Vector(0.1, 0.237, 0.107), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
			["panel"] = { type = "Model", model = "models/props_c17/gravestone003a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(12.027, 0, 0), angle = Angle(0, 0, 0), size = Vector(0.128, 0.229, 0.128), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
			["sopl+"] = { type = "Model", model = "models/Items/combine_rifle_ammo01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-31.25, -31.205, 2.321), angle = Angle(143.393, 0, -30.326), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
			["m++++"] = { type = "Model", model = "models/props_combine/breenlight.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, 0), angle = Angle(90, -90, 90), size = Vector(1.274, 3.609, 1.404), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
			["sopl++"] = { type = "Model", model = "models/Items/combine_rifle_ammo01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-31.13, 31.249, 2.321), angle = Angle(-143.734, 178.686, -30.326), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
			["sopl"] = { type = "Model", model = "models/Items/combine_rifle_ammo01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(31.308, -31.239, 2.321), angle = Angle(-146.081, 0, -30.326), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
			["m+++"] = { type = "Model", model = "models/mechanics/roboticslarge/claw2l.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(20, -20, 0), angle = Angle(-110, -135, 90), size = Vector(0.1, 0.237, 0.107), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} }
		})
	
		return
	end

	self.Sound2 = CreateSound(self, "ambient/energy/electric_loop.wav")
	self.Sound2:Play()
	self.Sound2:ChangeVolume(0)
	self.Sound2:ChangePitch(150)

	self.gun = ents.Create("laser_d2ent")
	self.gun:SetPos(self:GetPos() + self:GetUp() * -7 + self:GetRight() * 10)
	self.gun:SetAngles(self:GetAngles())
	self.gun:Spawn()
	self.gun:SetSolid(SOLID_NONE)
	self.gun:SetParent(self)
	self.gun._Think = function()
		local user = self:GetDriver()

		if not self:IsDroneDestroyed() and self:HasFuel() and user:IsValid() then		
			if user:KeyDown(IN_ATTACK) then
				local tr = self:GetAim()

				local start = self:GetUp() * -7 + self:GetRight() * 10
				local endpos = tr.HitPos

				self.Sound2:ChangeVolume(1)

				local ef = EffectData()
				ef:SetStart(start)
				ef:SetOrigin(endpos)
				ef:SetEntity(self)
				ef:SetAngles(Angle(0, 0, 255)) -- Color
				util.Effect("effect_dr2_beam", ef)

				if tr.Hit then
					ef:SetAngles(self:GetAngles())
					util.Effect("drone_sparks", ef)
				end

				local ent = tr.Entity
				if ent:IsValid() then
					ent:TakeDamage(4)
				end

				self:SetFuel(self.Fuel - 0.01)
			else
				self.Sound2:ChangeVolume(0)
			end

			self.gun:SetAngles(self:GetAngles() + Angle(user:EyeAngles().p < 0 and 0 or user:EyeAngles().p, user:EyeAngles().y, 0))
		else
			if self.Sound2 then self.Sound2:ChangeVolume(0) end
		end
	end

	self.gun2 = ents.Create("laser_d2ent")
	self.gun2:SetPos(self:GetPos() + self:GetUp() * -7 + self:GetRight() * -10)
	self.gun2:SetAngles(self:GetAngles())
	self.gun2:Spawn()
	self.gun2:SetSolid(SOLID_NONE)
	self.gun2:SetParent(self)
	self.gun2._Think = function()
		local user = self:GetDriver()

		if not self:IsDroneDestroyed() and self:HasFuel() and user:IsValid() then		
			if user:KeyDown(IN_ATTACK) then
				local tr = self:GetAim()

				local start = self:GetUp() * -7 + self:GetRight() * -10
				local endpos = tr.HitPos

				local ef = EffectData()
				ef:SetStart(start)
				ef:SetOrigin(endpos)
				ef:SetEntity(self)
				ef:SetAngles(Angle(0, 0, 255)) -- Color
				util.Effect("effect_dr2_beam", ef)

				if tr.Hit then
					ef:SetAngles(self:GetAngles())
					util.Effect("drone_sparks", ef)
				end

				local ent = tr.Entity
				if ent:IsValid() then
					ent:TakeDamage(4)
				end

				self:SetFuel(self.Fuel - 0.01)
			end

			self.gun2:SetAngles(self:GetAngles() + Angle(user:EyeAngles().p < 0 and 0 or user:EyeAngles().p, user:EyeAngles().y, 0))
		end
	end
end

function ENT:Think()
	self:_Think()

	if CLIENT then
		return 
	end

	if self.gun:IsValid() then self.gun._Think() end
	if self.gun2:IsValid() then self.gun2._Think() end

	self:NextThink(CurTime())
	return true
end