AddCSLuaFile()

ENT.Base = "drone_two_entity"
ENT.PrintName		= "Laser Drone Mark III"
ENT.Category        = "Drones 2: Light"
ENT.AdminOnly = true
ENT.Spawnable = true

ENT.Speed = 600
ENT.armor = 200

ENT.forward = 60
ENT.up = 5
ENT.cam_up = 10

ENT.Noise = true
ENT.EnableSound = false

ENT.shouldConsumeFuel = false
ENT.Mark = 3

ENT.UseAmmo = false

ENT.EnableParticles = true
ENT.NumParticles = 4
ENT.ParticleSize = 6
ENT.ParticleRadius = 5
ENT.PosParticles = { Vector(-34, -34, -1), Vector(-34, 34, -1), Vector(34, 34, -1), Vector(34, -34, -1) }
ENT.VelocityParticles = { Vector(-12, 12, 0), Vector(-12, -12, 0), Vector(12, -12, 0), Vector(12, 12, 0) }

function ENT:Initialize()
	self:_Initialize("models/props_phx/construct/metal_plate1.mdl", 200)

	if CLIENT then
		self:SetElements({
			["m+++++++++"] = { type = "Model", model = "models/props_combine/combine_mine01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-1.596, 0, -2.837), angle = Angle(180, 90, 0), size = Vector(0.54, 0.734, 0.33), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001", skin = 0, bodygroup = {} },
			["tur"] = { type = "Model", model = "models/Combine_turrets/Floor_turret.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-19.423, 19.611, -5.792), angle = Angle(-77.866, 44.763, 0), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["sopl+++"] = { type = "Model", model = "models/Items/combine_rifle_ammo01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(31.308, 31.215, 2.321), angle = Angle(34.429, 0, 149.298), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["tur+++"] = { type = "Model", model = "models/Combine_turrets/Floor_turret.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(20.958, -21.045, -5.047), angle = Angle(-77.866, -135.278, 0), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["huevogrejutbatarei++"] = { type = "Model", model = "models/props_interiors/radiator01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(12.423, -0.153, -3.958), angle = Angle(-180, 0, 0), size = Vector(0.059, 0.165, 0.045), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001", skin = 0, bodygroup = {} },
			["m++++"] = { type = "Model", model = "models/props_combine/breenlight.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, 0.87), angle = Angle(90, -90, 90), size = Vector(1.631, 3.703, 1.409), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001", skin = 0, bodygroup = {} },
			["sopl++"] = { type = "Model", model = "models/Items/combine_rifle_ammo01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-31.13, 31.249, 2.321), angle = Angle(-143.734, 178.686, -30.326), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["sopl"] = { type = "Model", model = "models/Items/combine_rifle_ammo01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(31.308, -31.239, 2.321), angle = Angle(-146.081, 0, -30.326), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m++++++"] = { type = "Model", model = "models/mechanics/roboticslarge/claw2l.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(20, 20, 0), angle = Angle(-110, 135, 90), size = Vector(0.1, 0.237, 0.107), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["tur++"] = { type = "Model", model = "models/Combine_turrets/Floor_turret.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-19.581, -19.4, -5.792), angle = Angle(-77.866, -44.909, 0), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001", skin = 0, bodygroup = {} },
			["shiet"] = { type = "Model", model = "models/props_combine/breenlight.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(7.238, 0, -4.421), angle = Angle(-90, 180, 0), size = Vector(0.5, 3.036, 0.649), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001", skin = 0, bodygroup = {} },
			["m+++++"] = { type = "Model", model = "models/props_combine/combine_light001a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-15.065, 0, -0.204), angle = Angle(-90, 90, 90), size = Vector(0.625, 0.625, 0.625), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001", skin = 0, bodygroup = {} },
			["shiet2+"] = { type = "Model", model = "models/props_combine/headcrabcannister01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(11.767, 2.71, -4.856), angle = Angle(-180, 0, -153.642), size = Vector(0.023, 0.037, 0.023), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001", skin = 0, bodygroup = {} },
			["sopl+"] = { type = "Model", model = "models/Items/combine_rifle_ammo01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-31.25, -31.205, 2.321), angle = Angle(143.393, 0, -30.326), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["light"] = { type = "Model", model = "models/props_junk/PopCan01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(6.877, 0, 2.851), angle = Angle(-180, 0, 0), size = Vector(0.819, 0.819, 0.819), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/masterinterface01c", skin = 0, bodygroup = {} },
			["huevogrejutbatarei"] = { type = "Model", model = "models/props_interiors/radiator01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(12.102, -0.153, 0.229), angle = Angle(0, 0, 0), size = Vector(0.125, 0.189, 0.185), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001", skin = 0, bodygroup = {} },
			["huevogrejutbatarei+"] = { type = "Model", model = "models/props_interiors/radiator01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(12.423, -0.153, 3.691), angle = Angle(0, 0, 0), size = Vector(0.059, 0.129, 0.035), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001", skin = 0, bodygroup = {} },
			["huevogrejutbatarei+++"] = { type = "Model", model = "models/props_interiors/radiator01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(12.423, -0.153, -5.085), angle = Angle(-180, 0, 0), size = Vector(0.059, 0.115, 0.025), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001", skin = 0, bodygroup = {} },
			["light+"] = { type = "Model", model = "models/props_junk/PopCan01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0.936, 0, 2.851), angle = Angle(-180, 0, 0), size = Vector(0.819, 0.819, 0.819), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/masterinterface01c", skin = 0, bodygroup = {} },
			["panel"] = { type = "Model", model = "models/props_c17/gravestone003a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(12.027, 0, 0), angle = Angle(0, 0, 0), size = Vector(0.128, 0.229, 0.128), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001", skin = 0, bodygroup = {} },
			["shiet2"] = { type = "Model", model = "models/props_combine/headcrabcannister01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(11.767, -2.711, -4.856), angle = Angle(-180, 0, 153.641), size = Vector(0.023, 0.037, 0.023), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001", skin = 0, bodygroup = {} },
			["m+++++++"] = { type = "Model", model = "models/mechanics/roboticslarge/claw2l.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-20, 20, 0), angle = Angle(-110, 45, 90), size = Vector(0.1, 0.237, 0.107), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["m++++++++"] = { type = "Model", model = "models/mechanics/roboticslarge/claw2l.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-20, -20, 0), angle = Angle(-110, -45, 90), size = Vector(0.1, 0.237, 0.107), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["light++"] = { type = "Model", model = "models/props_junk/PopCan01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-1.627, 0, -3.741), angle = Angle(0, 90, 0), size = Vector(0.939, 1.294, 0.939), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/masterinterface01c", skin = 0, bodygroup = {} },
			["tur+"] = { type = "Model", model = "models/Combine_turrets/Floor_turret.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(20.959, 20.938, -5.047), angle = Angle(-77.866, 133.677, 0), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["m+++"] = { type = "Model", model = "models/mechanics/roboticslarge/claw2l.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(20, -20, 0), angle = Angle(-110, -135, 90), size = Vector(0.1, 0.237, 0.107), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} }
		})
	
		return
	end

	self.Sound2 = CreateSound(self, "ambient/energy/electric_loop.wav")
	self.Sound2:Play()
	self.Sound2:ChangeVolume(0)
	self.Sound2:ChangePitch(150)

	self.gun = ents.Create("laser_d2ent")
	self.gun:SetPos(self:GetPos() + self:GetUp() * -7 + self:GetRight() * 10 + self:GetForward() * 10)
	self.gun:SetAngles(self:GetAngles())
	self.gun:Spawn()
	self.gun:SetSolid(SOLID_NONE)
	self.gun:SetParent(self)
	self.gun._Think = function()
		local user = self:GetDriver()

		if not self:IsDroneDestroyed() and self:HasFuel() and user:IsValid() then
			if user:KeyDown(IN_ATTACK) then
				local tr = self:GetAim()

				local start = self:GetUp() * -7 + self:GetRight() * 10 + self:GetForward() * 10
				local endpos = tr.HitPos

				self.Sound2:ChangeVolume(1)

				local ef = EffectData()
				ef:SetStart(start)
				ef:SetOrigin(endpos)
				ef:SetEntity(self)
				ef:SetAngles(Angle(255, 0, 0)) -- Color
				util.Effect("effect_dr2_beam", ef)

				if tr.Hit then
					if math.random(1,7) == 5 then
						ef:SetAngles(self:GetAngles())
						util.Effect("drone_sparks", ef)
					end
				end

				local ent = tr.Entity
				if ent:IsValid() then
					ent:TakeDamage(2.5)
				end
			else
				self.Sound2:ChangeVolume(0)
			end

			self.gun:SetAngles(self:GetAngles() + Angle(user:EyeAngles().p < 0 and 0 or user:EyeAngles().p, user:EyeAngles().y, 0))
		else
			if self.Sound2 then self.Sound2:ChangeVolume(0) end
		end
	end

	self.gun2 = ents.Create("laser_d2ent")
	self.gun2:SetPos(self:GetPos() + self:GetUp() * -7 + self:GetRight() * -10 + self:GetForward() * 10)
	self.gun2:SetAngles(self:GetAngles())
	self.gun2:Spawn()
	self.gun2:SetSolid(SOLID_NONE)
	self.gun2:SetParent(self)
	self.gun2._Think = function()
		local user = self:GetDriver()

		if not self:IsDroneDestroyed() and self:HasFuel() and user:IsValid() then	
			if user:KeyDown(IN_ATTACK) then
				local tr = self:GetAim()

				local start = self:GetUp() * -7 + self:GetRight() * -10 + self:GetForward() * 10
				local endpos = tr.HitPos

				local ef = EffectData()
				ef:SetStart(start)
				ef:SetOrigin(endpos)
				ef:SetEntity(self)
				ef:SetAngles(Angle(0, 0, 255)) -- Color
				util.Effect("effect_dr2_beam", ef)

				if tr.Hit then
					if math.random(1,7) == 5 then
						ef:SetAngles(self:GetAngles())
						util.Effect("drone_sparks", ef)
					end
				end

				local ent = tr.Entity
				if ent:IsValid() then
					ent:TakeDamage(2.5)
				end
			end

			self.gun2:SetAngles(self:GetAngles() + Angle(user:EyeAngles().p < 0 and 0 or user:EyeAngles().p, user:EyeAngles().y, 0))
		end
	end
	
	self.gun3 = ents.Create("laser_d2ent")
	self.gun3:SetPos(self:GetPos() + self:GetUp() * -7 + self:GetRight() * 10 + self:GetForward() * -10)
	self.gun3:SetAngles(self:GetAngles())
	self.gun3:Spawn()
	self.gun3:SetSolid(SOLID_NONE)
	self.gun3:SetParent(self)
	self.gun3._Think = function()
		local user = self:GetDriver()

		if not self:IsDroneDestroyed() and self:HasFuel() and user:IsValid() then	
			if user:KeyDown(IN_ATTACK) then
				local tr = self:GetAim()

				local start = self:GetUp() * -7 + self:GetRight() * 10 + self:GetForward() * -10
				local endpos = tr.HitPos

				local ef = EffectData()
				ef:SetStart(start)
				ef:SetOrigin(endpos)
				ef:SetEntity(self)
				ef:SetAngles(Angle(0, 255, 0)) -- Color
				util.Effect("effect_dr2_beam", ef)

				if tr.Hit then
					if math.random(1,7) == 5 then
						ef:SetAngles(self:GetAngles())
						util.Effect("drone_sparks", ef)
					end
				end

				local ent = tr.Entity
				if ent:IsValid() then
					ent:TakeDamage(2.5)
				end
			end

			self.gun3:SetAngles(self:GetAngles() + Angle(user:EyeAngles().p < 0 and 0 or user:EyeAngles().p, user:EyeAngles().y, 0))
		end
	end
	
	self.gun4 = ents.Create("laser_d2ent")
	self.gun4:SetPos(self:GetPos() + self:GetUp() * -7 + self:GetRight() * -10 + self:GetForward() * -10)
	self.gun4:SetAngles(self:GetAngles())
	self.gun4:Spawn()
	self.gun4:SetSolid(SOLID_NONE)
	self.gun4:SetParent(self)
	self.gun4._Think = function()
		local user = self:GetDriver()

		if not self:IsDroneDestroyed() and self:HasFuel() and user:IsValid() then	
			if user:KeyDown(IN_ATTACK) then
				local tr = self:GetAim()

				local start = self:GetUp() * -7 + self:GetRight() * -10 + self:GetForward() * -10
				local endpos = tr.HitPos

				local ef = EffectData()
				ef:SetStart(start)
				ef:SetOrigin(endpos)
				ef:SetEntity(self)
				ef:SetAngles(Angle(255, 255, 0)) -- Color
				util.Effect("effect_dr2_beam", ef)

				if tr.Hit then
					if math.random(1,7) == 5 then
						ef:SetAngles(self:GetAngles())
						util.Effect("drone_sparks", ef)
					end
				end

				local ent = tr.Entity
				if ent:IsValid() then
					ent:TakeDamage(2.5)
				end
			end

			self.gun4:SetAngles(self:GetAngles() + Angle(user:EyeAngles().p < 0 and 0 or user:EyeAngles().p, user:EyeAngles().y, 0))
		end
	end
end

function ENT:Think()
	self:_Think()

	if CLIENT then
		return 
	end

	if self.gun:IsValid() then self.gun._Think() end
	if self.gun2:IsValid() then self.gun2._Think() end
	if self.gun3:IsValid() then self.gun3._Think() end
	if self.gun4:IsValid() then self.gun4._Think() end

	self:NextThink(CurTime())
	return true
end