AddCSLuaFile()

ENT.Base = "drone_two_entity"
ENT.PrintName		= "Medic Drone Mark II"
ENT.Category        = "Drones 2: Support"
ENT.Spawnable = true

ENT.Speed = 650
ENT.armor = 150

ENT.forward = 60
ENT.up = 5
ENT.cam_up = 8

ENT.Noise = false
ENT.MaxFuel = 120

ENT.Mark = 2

ENT.EnableParticles = true
ENT.NumParticles = 1
ENT.ParticleSize = 12
ENT.ParticleRadius = 5
ENT.PosParticles = { Vector(0, 0, -1) }

ENT.SoundName = "hl1/ambience/alien_minddrill.wav"
ENT.PropellersPitch = 255

ENT.UseAmmo = false

function ENT:Initialize()
	self:_Initialize("models/props_phx/construct/metal_plate1.mdl", 200)

	if CLIENT then
		self:SetElements({
			["m+"] = { type = "Model", model = "models/Items/HealthKit.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-5.715, -6.753, 0), angle = Angle(0, 0, -90), size = Vector(0.95, 0.95, 0.95), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m"] = { type = "Model", model = "models/Items/car_battery01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, 0), angle = Angle(180, 0, 0), size = Vector(2, 1, 1), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_debris/building_template010a", skin = 0, bodygroup = {} },
			["m2++"] = { type = "Model", model = "models/combine_turrets/floor_turret.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(20, -20, 0), angle = Angle(-90, -135, 0), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
			["m2+++++"] = { type = "Model", model = "models/Items/battery.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-5.715, 8.831, 1.557), angle = Angle(0, -90, -90), size = Vector(1.08, 1.08, 1.08), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m2"] = { type = "Model", model = "models/combine_turrets/floor_turret.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-20, 20, 0), angle = Angle(-90, 45, 0), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
			["m2+"] = { type = "Model", model = "models/combine_turrets/floor_turret.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-20, -20, 0), angle = Angle(-90, -45, 0), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
			["m2+++"] = { type = "Model", model = "models/combine_turrets/floor_turret.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(20, 20, 0), angle = Angle(-90, 135, 0), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} },
			["m2++++"] = { type = "Model", model = "models/Items/battery.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-5.715, 8.831, -1.558), angle = Angle(0, -90, -90), size = Vector(1.08, 1.08, 1.08), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m++"] = { type = "Model", model = "models/XQM/Rails/loop_left.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0.518, -6.753, 0), angle = Angle(180, 78.311, 0), size = Vector(0.1, 0.1, 0.1), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_c17/concrete_barrier", skin = 0, bodygroup = {} }
		})
	
		return
	end

	self.Sound = CreateSound(self, "ambient/energy/electric_loop.wav")
	self.Sound:Play()
	self.Sound:ChangeVolume(0)
	self.Sound:ChangePitch(90)

	self.gun = ents.Create("laser_d2ent")
	self.gun:SetPos(self:GetPos() - self:GetUp() * 5 + self:GetRight() * 10)
	self.gun:SetAngles(self:GetAngles())
	self.gun:Spawn()
	self.gun:SetSolid(SOLID_NONE)
	self.gun:SetParent(self)
	self.gun._Think = function()
		local user = self:GetDriver()

		if not self:IsDroneDestroyed() and self:HasFuel() and user:IsValid() then		
			if user:KeyDown(IN_ATTACK) then
				local tr = self:GetAim()

				local start = -self:GetUp() * 5 + self:GetRight() * 10
				local endpos = tr.HitPos

				self.Sound:ChangeVolume(1)

				local ef = EffectData()
				ef:SetStart(start)
				ef:SetOrigin(endpos)
				ef:SetEntity(self)
				ef:SetAngles(Angle(0, 255, 0))
				util.Effect("effect_dr2_beam", ef)

				/*if tr.Hit then
					ef:SetAngles(self:GetAngles())
					util.Effect("drone_sparks", ef)
				end*/

				local ent = tr.Entity 
				local playr = ent:GetNWEntity("user")
				if ent:GetClass() == "entity_damager_drone" then playr:SetHealth(math.min(playr:GetMaxHealth(), playr:Health() + 1)) end
				if ent:IsValid() and ent:IsPlayer() or ent:IsNPC() then
					ent:SetHealth(math.min(ent:GetMaxHealth(), ent:Health() + 1))
				end

				self:SetFuel(self.Fuel - 0.01)
			else
				self.Sound:ChangeVolume(0)
			end

			self.gun:SetAngles(self:GetAngles() + Angle(user:EyeAngles().p < 0 and 0 or user:EyeAngles().p, user:EyeAngles().y, 0))
		else
			if self.Sound then self.Sound:ChangeVolume(0) end
		end
	end

	self.gun2 = ents.Create("laser_d2ent")
	self.gun2:SetPos(self:GetPos() - self:GetUp() * 5 + self:GetRight() * -10)
	self.gun2:SetAngles(self:GetAngles())
	self.gun2:Spawn()
	self.gun2:SetSolid(SOLID_NONE)
	self.gun2:SetParent(self)
	self.gun2._Think = function()
		local user = self:GetDriver()

		if not self:IsDroneDestroyed() and self:HasFuel() and user:IsValid() then		
			if user:KeyDown(IN_ATTACK) then
				local tr = self:GetAim()

				local start = -self:GetUp() * 5 + self:GetRight() * -10
				local endpos = tr.HitPos

				local ef = EffectData()
				ef:SetStart(start)
				ef:SetOrigin(endpos)
				ef:SetEntity(self)
				ef:SetAngles(Angle(0, 255, 0))
				util.Effect("effect_dr2_beam", ef)

				/*if tr.Hit then
					ef:SetAngles(self:GetAngles())
					util.Effect("drone_sparks", ef)
				end*/

				local ent = tr.Entity
				if ent:IsValid() and ent:IsPlayer() or ent:IsNPC() then
					ent:SetHealth(math.min(ent:GetMaxHealth(), ent:Health() + 1))
				end

				self:SetFuel(self.Fuel - 0.01)
			end

			self.gun2:SetAngles(self:GetAngles() + Angle(user:EyeAngles().p < 0 and 0 or user:EyeAngles().p, user:EyeAngles().y, 0))
		end
	end
end

function ENT:Think()
	self:_Think()

	if CLIENT then
		return 
	end

	if self.gun:IsValid() then self.gun._Think() end
	if self.gun2:IsValid() then self.gun2._Think() end

	self:NextThink(CurTime())
	return true
end