AddCSLuaFile()

ENT.Base = "drone_two_entity"
ENT.PrintName		= "Melon Drone"
ENT.Category        = "Drones 2: Misc"
ENT.AdminOnly = true
ENT.Spawnable = true

ENT.Speed = 1300
ENT.armor = 1000

ENT.forward = 50
ENT.up = 5
ENT.cam_up = 4

ENT.HUD_hudColor = Color(0, 255, 0, 255)
ENT.HUD_textColor = Color(0, 255, 0, 255)

ENT.Mark = 3
ENT.shouldConsumeFuel = false

ENT.UseAmmo = false

ENT.CustomHUD = function(drone, x, y)
	draw.SimpleText("Melon powerz activated", "Trebuchet24", x - 115, y - 80, Color(0, 255, 0), TEXT_ALIGN_RIGHT)
end

function ENT:Initialize()
	self:_Initialize("models/props_junk/watermelon01.mdl", 2000)

	if CLIENT then
		self:SetElements({
			["m"] = { type = "Model", model = "models/props_junk/watermelon01.mdl", bone = "", rel = "", pos = Vector(0, 0, 0), angle = Angle(0, 0, 0), size = Vector(2, 2, 2), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m2"] = { type = "Model", model = "models/props_c17/TrapPropeller_Blade.mdl", bone = "", rel = "", pos = Vector(0, 0, 20), angle = Angle(0, 0, 0), size = Vector(0.5, 0.5, 0.5), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
		})

		return
	end

	self.gun = ents.Create("minigun_dr2ent")
	self.gun:SetPos(self:GetPos() + self:GetForward() * 10 + self:GetUp() * -10 + self:GetRight() * 10)
	self.gun:SetAngles(self:GetAngles())
	self.gun:Spawn()
	self.gun:SetSolid(SOLID_NONE)
	self.gun:SetParent(self)
	self.gun._Think = function()
		--Minigun and savers
		local user = self:GetDriver()

		if not self:IsDroneDestroyed() and self:HasFuel() and user:IsValid() then		
			if user:KeyDown(IN_ATTACK) then
				self.gun:Switch(true)

				if CurTime() > self.nextshoot then
					local bullet = {}
					bullet.Num = 1
					bullet.Src = self.gun:GetPos() + self.gun:GetForward() * 20
					bullet.Dir = self:GetDriverDirection()
					bullet.Spread = Vector(0.01, 0.01, 0.01)
					bullet.Tracer = 1	
					bullet.Force = 50000
					bullet.Damage = 500
					bullet.Attacker = self.Owner
					 
					user:EmitSound("weapons/shotgun/shotgun_fire6.wav", 100, math.random(200, 250))

					self.gun:FireBullets(bullet)

					self.nextshoot = CurTime()
				end
			else
				self.gun:Switch(false)
			end

			self.gun:SetAngles(self:GetAngles() + Angle(user:EyeAngles().p < 0 and 0 or user:EyeAngles().p, user:EyeAngles().y, 0))
		else
			self.gun:Switch(false)
		end
	end
end

function ENT:Think()
	self:_Think()

	if CLIENT then self.WElements["m2"].angle.y = CurTime() * 2500 return end

	if self.gun:IsValid() then self.gun._Think() end

	self:NextThink(CurTime())
	return true
end
