AddCSLuaFile()

ENT.Base = "drone_two_entity"
ENT.PrintName		= "Nano Drone Mark I"
ENT.Category        = "Drones 2: Exploration"
ENT.Spawnable = true

ENT.Speed = 300
ENT.armor = 60

ENT.forward = 10
ENT.up = -15
ENT.cam_up = 3.5

ENT.PropellersPitch = 200
ENT.EnableSound = true

ENT.MaxFuel = 75

ENT.UseAmmo = false

function ENT:Initialize()
	if CLIENT then
		self:SetElements({
			["m+"] = { type = "Model", model = "models/props_combine/combine_binocular01.mdl", bone = "", rel = "", pos = Vector(1, 1, 0), angle = Angle(-90, 135, 0), size = Vector(0.1, 0.1, 0.1), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m"] = { type = "Model", model = "models/props_combine/combine_binocular01.mdl", bone = "", rel = "", pos = Vector(-1, 1, 0), angle = Angle(-90, 45, 0), size = Vector(0.1, 0.1, 0.1), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m++"] = { type = "Model", model = "models/props_combine/combine_binocular01.mdl", bone = "", rel = "", pos = Vector(-1, -1, 0), angle = Angle(-90, -45, 0), size = Vector(0.1, 0.1, 0.1), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m+++"] = { type = "Model", model = "models/props_combine/combine_binocular01.mdl", bone = "", rel = "", pos = Vector(1, -1, 0), angle = Angle(-90, -135, 0), size = Vector(0.1, 0.1, 0.1), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },

			["m6"] = { type = "Model", model = "models/hunter/plates/plate1x1.mdl", bone = "", rel = "", pos = Vector(3, -3, 0), angle = Angle(0, 0, 0), size = Vector(0.08, 0.08, 0.08), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/airboat/airboat_blur02", skin = 0, bodygroup = {} },
			["m7"] = { type = "Model", model = "models/hunter/plates/plate1x1.mdl", bone = "", rel = "", pos = Vector(3, 3, 0), angle = Angle(0, 0, 0), size = Vector(0.08, 0.08, 0.08), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/airboat/airboat_blur02", skin = 0, bodygroup = {} },
			["m8"] = { type = "Model", model = "models/hunter/plates/plate1x1.mdl", bone = "", rel = "", pos = Vector(-3, -3, 0), angle = Angle(0, 0, 0), size = Vector(0.08, 0.08, 0.08), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/airboat/airboat_blur02", skin = 0, bodygroup = {} },
			["m9"] = { type = "Model", model = "models/hunter/plates/plate1x1.mdl", bone = "", rel = "", pos = Vector(-3, 3, 0), angle = Angle(0, 0, 0), size = Vector(0.08, 0.08, 0.08), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/airboat/airboat_blur02", skin = 0, bodygroup = {} }
		})
	end

	self:_Initialize("models/hunter/plates/plate.mdl", 3)
end

function ENT:OnDestroyed() end
function ENT:Think()
	self:_Think()

	if CLIENT then
		if self:HasFuel() and not self:IsDroneDestroyed() then
			self.WElements["m6"].angle = Angle(0, CurTime() * 1500, 0)
			self.WElements["m7"].angle = Angle(0, CurTime() * 1500, 0)
			self.WElements["m8"].angle = Angle(0, CurTime() * 1500, 0)
			self.WElements["m9"].angle = Angle(0, CurTime() * 1500, 0)
		end

		return 
	end

	self:NextThink(CurTime())
	return true
end

function ENT:DoSound()
	self.Sound = CreateSound(self, self.SoundName)
	self.Sound:Play()
	self.Sound:ChangeVolume(0.1)
end