AddCSLuaFile()

ENT.Base = "drone_two_entity"
ENT.PrintName		= "Repair Drone Mark II"
ENT.Category        = "Drones 2: Support"
ENT.Spawnable = true

ENT.Speed = 650
ENT.armor = 150

ENT.forward = 60
ENT.up = 5
ENT.cam_up = 6

ENT.Noise = false
ENT.MaxFuel = 180

ENT.Mark = 2

ENT.EnableParticles = true
ENT.NumParticles = 1
ENT.ParticleSize = 6
ENT.ParticleRadius = 10
ENT.PosParticles = { Vector(0, 0, -5) }

ENT.UseAmmo = false

ENT.SoundName = "hl1/ambience/alien_minddrill.wav"
ENT.PropellersPitch = 255

function ENT:Initialize()
	self:_Initialize("models/props_phx/construct/metal_plate1.mdl", 200)

	if CLIENT then
		self:SetElements({
			["m+"] = { type = "Model", model = "models/items/battery.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(8.831, 0, -0.519), angle = Angle(-90, 180, 0), size = Vector(1, 3, 2), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m+++++"] = { type = "Model", model = "models/props_combine/breenconsole.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-9.87, 0, -3.636), angle = Angle(0, -90, 15.194), size = Vector(0.3, 0.43, 0.23), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m+++++++"] = { type = "Model", model = "models/items/battery.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(8.831, 0, 4.675), angle = Angle(90, 0, 0), size = Vector(1.6, 3, 2), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m++++"] = { type = "Model", model = "models/props_combine/breenlight.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0.518, 6.791, 2), angle = Angle(90, 0, 0), size = Vector(0.82, 0.82, 0.82), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/combine_turrets/ground_turret/ground_turret01", skin = 0, bodygroup = {} },
			["m++++++"] = { type = "Model", model = "models/props_combine/combine_lock01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-10.91, -0.519, 0.518), angle = Angle(90, 90, 0), size = Vector(0.4, 0.4, 0.4), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m++"] = { type = "Model", model = "models/props_combine/combine_emitter01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-3.636, 0, 2.596), angle = Angle(180, 180, 180), size = Vector(0.4, 0.4, 0.497), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m+++"] = { type = "Model", model = "models/props_combine/breenlight.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0.518, -6.792, 2), angle = Angle(90, 0, 0), size = Vector(0.82, 0.82, 0.82), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/combine_turrets/ground_turret/ground_turret01", skin = 0, bodygroup = {} }
		})
	
		return
	end

	self.Sound = CreateSound(self, "ambient/energy/electric_loop.wav")
	self.Sound:Play()
	self.Sound:ChangeVolume(0)
	self.Sound:ChangePitch(90)

	self.gun = ents.Create("laser_d2ent")
	self.gun:SetPos(self:GetPos() + self:GetRight() * 9)
	self.gun:SetAngles(self:GetAngles())
	self.gun:Spawn()
	self.gun:SetSolid(SOLID_NONE)
	self.gun:SetParent(self)
	self.gun._Think = function()
		local user = self:GetDriver()

		if not self:IsDroneDestroyed() and self:HasFuel() and user:IsValid() then	
			if user:KeyDown(IN_ATTACK) then
				local tr = self:GetAim()

				local start = self:GetRight() * 9
				local endpos = tr.HitPos

				self.Sound:ChangeVolume(1)

				local ef = EffectData()
				ef:SetStart(start)
				ef:SetOrigin(endpos)
				ef:SetEntity(self)
				ef:SetAngles(Angle(0, 255, 255))
				util.Effect("effect_dr2_beam", ef)

				/*if tr.Hit then
					ef:SetAngles(self:GetAngles())
					util.Effect("drone_sparks", ef)
				end*/

				local ent = tr.Entity
				if ent:IsValid() and ent.IS_DRONE then
					ent:SetArm(ent.armor + 0.5)
				end

				self:SetFuel(self.Fuel - 0.01)
			else
				self.Sound:ChangeVolume(0)
			end

			self.gun:SetAngles(self:GetAngles() + Angle(user:EyeAngles().p < 0 and 0 or user:EyeAngles().p, user:EyeAngles().y, 0))
		else
			if self.Sound then self.Sound:ChangeVolume(0) end
		end
	end

	self.gun2 = ents.Create("laser_d2ent")
	self.gun2:SetPos(self:GetPos() + self:GetRight() * -9)
	self.gun2:SetAngles(self:GetAngles())
	self.gun2:Spawn()
	self.gun2:SetSolid(SOLID_NONE)
	self.gun2:SetParent(self)
	self.gun2._Think = function()
		local user = self:GetDriver()

		if not self:IsDroneDestroyed() and self:HasFuel() and user:IsValid() then		
			if user:KeyDown(IN_ATTACK) then
				local tr = self:GetAim()

				local start = self:GetRight() * -9
				local endpos = tr.HitPos

				local ef = EffectData()
				ef:SetStart(start)
				ef:SetOrigin(endpos)
				ef:SetEntity(self)
				ef:SetAngles(Angle(0, 255, 255))
				util.Effect("effect_dr2_beam", ef)

				/*if tr.Hit then
					ef:SetAngles(self:GetAngles())
					util.Effect("drone_sparks", ef)
				end*/

				local ent = tr.Entity
				if ent:IsValid() and ent.IS_DRONE then
					ent:SetArm(ent.armor + 0.5)
				end

				self:SetFuel(self.Fuel - 0.01)
			end

			self.gun2:SetAngles(self:GetAngles() + Angle(user:EyeAngles().p < 0 and 0 or user:EyeAngles().p, user:EyeAngles().y, 0))
		end
	end
end

function ENT:Think()
	self:_Think()

	if CLIENT then
		return 
	end

	if self.gun:IsValid() then self.gun._Think() end
	if self.gun2:IsValid() then self.gun2._Think() end

	self:NextThink(CurTime())
	return true
end