AddCSLuaFile()

ENT.Base = "drone_two_entity"
ENT.PrintName		= "T-12 Artillery Drone"
ENT.Category        = "Drones 2: Heavy"
ENT.Spawnable = true

ENT.Speed = 200
ENT.armor = 3000

ENT.forward = 70
ENT.up = 5
ENT.cam_up = 25

ENT.Ammo = 75
ENT.MaxAmmo = 100
ENT.AmmoBox = 1
ENT.AmmoType = "item_rpg_round"
ENT.UseAmmo = true

ENT.Ammo2 = 5000
ENT.MaxAmmo2 = 10000
ENT.AmmoBox2 = 1
ENT.AmmoType2 = "item_ammo_357"
ENT.UseAmmo2 = true

ENT.SoundName = "npc/attack_helicopter/aheli_rotor_loop1.wav"
ENT.PropellersPitch = 150

function ENT:Initialize()
	self:_Initialize("models/props_phx/trains/track_512.mdl", 35000)

	if CLIENT then
		self:SetElements({
		["plat+"] = { type = "Model", model = "models/xqm/jetenginepropeller.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-204, 0, 7.329), angle = Angle(90, 0, 0), size = Vector(4.644, 4.644, 4.644), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
		["curv"] = { type = "Model", model = "models/props_phx/construct/metal_plate_curve360.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-204, 0, -0.977), angle = Angle(0, 0, 0), size = Vector(1.2, 1.2, 0.314), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
		["base+"] = { type = "Model", model = "models/props_combine/combinetrain01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-55.123, 0, 0), angle = Angle(-180, 180, 0), size = Vector(0.282, 0.966, 0.072), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
		["plat"] = { type = "Model", model = "models/xqm/jetenginepropeller.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(204, 0, 7.329), angle = Angle(90, 0, 0), size = Vector(4.644, 4.644, 4.644), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
		["curv+"] = { type = "Model", model = "models/props_phx/construct/metal_plate_curve360.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(204, 0, -0.977), angle = Angle(0, 0, 0), size = Vector(1.2, 1.2, 0.314), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
		["most+"] = { type = "Model", model = "models/props_combine/combine_bridge.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-11.45, 0, -9.212), angle = Angle(0, 180, 0), size = Vector(0.488, 0.884, 0.122), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001", skin = 0, bodygroup = {} },
		["base"] = { type = "Model", model = "models/props_combine/combinetrain01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(55.122, 0, 0), angle = Angle(-180, 0, 0), size = Vector(0.282, 0.966, 0.072), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001", skin = 0, bodygroup = {} },
		["temp"] = { type = "Model", model = "models/props_phx/trains/track_512.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, 0), angle = Angle(0, 0, 0), size = Vector(1, 1, 1), color = Color(255, 255, 255, 0), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
		["hand"] = { type = "Model", model = "models/Mechanics/roboticslarge/k4.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, -4.039), angle = Angle(0, 0, 90), size = Vector(0.739, 0.236, 0.739), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
		["most"] = { type = "Model", model = "models/props_combine/combine_bridge.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(11.449, 0, -9.212), angle = Angle(0, 0, 0), size = Vector(0.488, 0.884, 0.122), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001", skin = 0, bodygroup = {} }
		})
	
		return
	end

	self.gun = ents.Create("cannon_dr2ent")
	self.gun:SetPos(self:GetPos() + self:GetForward() * -40 + self:GetUp() * -25)
	self.gun:SetAngles(self:GetAngles())
	self.gun:Spawn()
	self.gun:SetSolid(SOLID_NONE)
	self.gun:SetParent(self)
	self.gun._Think = function()
		local user = self:GetDriver()

		if not self:IsDroneDestroyed() and self:HasFuel() and user:IsValid() then		
			if user:KeyDown(IN_ATTACK) and self:HasAmmo() then
				self.gun:Switch(true)

				if CurTime() > self.nextshoot then			
					local ammo = ents.Create("projectile_dent")
					ammo:SetPos(self.gun:GetPos())
					ammo:SetOwner(self.Owner)
					ammo:SetAngles(self.gun:GetAngles())
					ammo:Spawn()
				
					self.gun:EmitSound("ambient/explosions/explode_4.wav")
				
					local physamm = ammo:GetPhysicsObject()
				
					physamm:AddVelocity(self:GetDriverDirection() * 5000)

					self:SetAmmo(self.Ammo - 1)

					self.nextshoot = CurTime() + 5
					
					timer.Simple(4, function() 
						if !IsValid(self) or !self then return end
						
						self:EmitSound("weapons/shotgun/shotgun_cock.wav", 100, 60)
					end)
				end
			else
				self.gun:Switch(false)
			end

			self.gun:SetAngles(self:GetAngles() + Angle(user:EyeAngles().p < 0 and 0 or user:EyeAngles().p, user:EyeAngles().y, 0))
		else
			self.gun:Switch(false)
		end
	end

	self.nextshoot2 = 0
	self.gun2 = ents.Create("machinegun_dr2ent")
	self.gun2:SetPos(self:GetPos() + self:GetForward() * 40 + self:GetUp() * -25)
	self.gun2:SetAngles(self:GetAngles())
	self.gun2:Spawn()
	self.gun2:SetSolid(SOLID_NONE)
	self.gun2:SetParent(self)
	self.gun2._Think = function()
		local user = self:GetDriver()

		if not self:IsDroneDestroyed() and self:HasFuel() and user:IsValid() then
			if user:KeyDown(IN_ATTACK2) and self:HasAmmo2() then
				if CurTime() > self.nextshoot2 then
					self.gun2:Switch(true)
					
					local bullet = {}
					bullet.Num = 1
					bullet.Src = self.gun2:GetPos() + self.gun2:GetForward() * 20
					bullet.Dir = self:GetDriverDirection()
					bullet.Spread = Vector(0.01, 0.01, 0.01)
					bullet.Tracer = 2	
					bullet.Force = 200
					bullet.Damage = 75
					bullet.Attacker = self.Owner
					
					user:EmitSound("weapons/357_fire2.wav", 100, 100)

					self:SetAmmo2(self.Ammo2 - 1)
					self.gun2:FireBullets(bullet)

					self.nextshoot2 = CurTime() + 0.05
				end
			else
				self.gun2:Switch(false)
			end
			
			self.gun2:SetAngles(self:GetAngles() + Angle(user:EyeAngles().p < 0 and 0 or user:EyeAngles().p, user:EyeAngles().y, 0))
		else
			self.gun2:Switch(false)
		end
	end
end

function ENT:PhysicsCollide(data, phys)
	if CLIENT then return end

	if data.DeltaTime < 0.3 then return end

	--Sure drone has to get damage when it collides
	if data.Speed > 1000 then
		local driver = self:GetDriver()

		self:TakeDamage(math.Round(math.Clamp(data.Speed / 70, 5, 15)))
		
		local phys = self:GetPhysicsObject()
		if phys:IsValid() then
			phys:SetVelocity(VectorRand() * 200)
			phys:AddAngleVelocity(VectorRand() * 200)
		end
	end
end

function ENT:Think()
	self:_Think()

	if CLIENT then
		if self:HasFuel() and not self:IsDroneDestroyed() then

			self.WElements["plat"].angle.r = CurTime() * -5000
			self.WElements["plat+"].angle.r = CurTime() * -5000
		end

		return 
	end

	if self.gun:IsValid() then self.gun._Think() end
	if self.gun2:IsValid() then self.gun2._Think() end

	self:NextThink(CurTime())
	return true
end