AddCSLuaFile()

ENT.Base = "drone_two_entity"
ENT.PrintName		= "Warrior Drone Mark III"
ENT.Category        = "Drones 2: Light"
ENT.AdminOnly = true
ENT.Spawnable = true

ENT.Speed = 750
ENT.armor = 280

ENT.forward = 60
ENT.up = 5
ENT.cam_up = 13

ENT.Noise = false
ENT.EnableSound = false
ENT.Mark = 3
ENT.shouldConsumeFuel = false

ENT.EnableParticles = true
ENT.NumParticles = 4
ENT.ParticleSize = 6
ENT.ParticleRadius = 4
ENT.PosParticles = { Vector(-28, -28, -4), Vector(-28, 28, -4), Vector(28, 28, -4), Vector(28, -28, -4) }

ENT.SoundName = "hl1/ambience/alien_minddrill.wav"
ENT.PropellersPitch = 255

ENT.Ammo = 3000
ENT.MaxAmmo = 3000

function ENT:Initialize()
	self:_Initialize("models/props_phx/construct/metal_plate1.mdl", 300)

	if CLIENT then
		self:SetElements({
			["m+"] = { type = "Model", model = "models/props_combine/combine_booth_short01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, -2.597), angle = Angle(90, 180, 0), size = Vector(0.129, 0.129, 0.17), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m3++++"] = { type = "Model", model = "models/props_combine/combine_emitter01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, -5.715, -0.519), angle = Angle(0, 0, -50.91), size = Vector(0.699, 0.699, 0.699), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m+++++++"] = { type = "Model", model = "models/props_combine/combine_binocular01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-15, 15, 0.518), angle = Angle(90, -135, 0), size = Vector(0.625, 0.625, 0.95), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m3"] = { type = "Model", model = "models/props_combine/combinecamera001.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(10, 10, -0.5), angle = Angle(140, 135, 180), size = Vector(1.2, 1.2, 1.2), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m++++"] = { type = "Model", model = "models/props_combine/combine_emitter01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, 4.675), angle = Angle(180, 180, 180), size = Vector(0.625, 0.625, 0.625), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m3+++"] = { type = "Model", model = "models/props_combine/combinecamera001.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-10, 10, -0.5), angle = Angle(140, 45, 180), size = Vector(1.2, 1.2, 1.2), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m++++++++"] = { type = "Model", model = "models/props_combine/combine_binocular01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-15, -15, 0.518), angle = Angle(90, 135, 0), size = Vector(0.625, 0.625, 0.95), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m3+++++"] = { type = "Model", model = "models/props_combine/combine_emitter01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 5.714, -0.519), angle = Angle(0, 0, 50), size = Vector(0.699, 0.699, 0.699), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m+++++"] = { type = "Model", model = "models/props_combine/combine_binocular01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(15, -15, 0.518), angle = Angle(90, 45, 0), size = Vector(0.625, 0.625, 0.95), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m3+"] = { type = "Model", model = "models/props_combine/combinecamera001.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(10, -10, -0.5), angle = Angle(140, -135, 180), size = Vector(1.2, 1.2, 1.2), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m3++"] = { type = "Model", model = "models/props_combine/combinecamera001.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-10, -10, -0.5), angle = Angle(140, -45, 180), size = Vector(1.2, 1.2, 1.2), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m"] = { type = "Model", model = "models/props_combine/combine_booth_short01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(0, 0, 0), angle = Angle(-90, 0, 0), size = Vector(0.1, 0.14, 0.18), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m++++++"] = { type = "Model", model = "models/props_combine/combine_binocular01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(15, 15, 0.518), angle = Angle(90, -45, 0), size = Vector(0.625, 0.625, 0.95), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m++"] = { type = "Model", model = "models/props_combine/combine_booth_short01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-1.558, 0, -1.3), angle = Angle(90, 0, 0), size = Vector(0.1, 0.1, 0.1), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["m+++"] = { type = "Model", model = "models/props_combine/combine_booth_short01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-1.558, 0, -0.519), angle = Angle(-90, 180, 0), size = Vector(0.1, 0.1, 0.1), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} }
		})
	
		return
	end

	self.gun = ents.Create("minigun_dr2ent")
	self.gun:SetPos(self:GetPos() + self:GetForward() * 10 + self:GetUp() * -4 + self:GetRight() * 10)
	self.gun:SetAngles(self:GetAngles())
	self.gun:Spawn()
	self.gun:SetSolid(SOLID_NONE)
	self.gun:SetParent(self)
	self.gun._Think = function()
		--Minigun and savers
		local user = self:GetDriver()

		if not self:IsDroneDestroyed() and self:HasFuel() and user:IsValid() then		
			if user:KeyDown(IN_ATTACK) and self:HasAmmo() then
				self.gun:Switch(true)

				if CurTime() > self.nextshoot then
					local bullet = {}
					bullet.Num = 1
					bullet.Src = self.gun:GetPos() + self.gun:GetForward() * 20
					bullet.Dir = self:GetDriverDirection()
					bullet.Spread = Vector(0.02, 0.02, 0.02)
					bullet.Tracer = 2	
					bullet.Force = 15
					bullet.Damage = 5
					bullet.Attacker = self.Owner
					 
					user:EmitSound("npc/strider/strider_minigun.wav", 100, math.random(200, 250))

					self.gun:FireBullets(bullet)

					self:SetAmmo(self.Ammo - 1)

					self.nextshoot = CurTime() + 0.01
				end
			else
				self.gun:Switch(false)
			end

			self.gun:SetAngles(self:GetAngles() + Angle(user:EyeAngles().p < 0 and 0 or user:EyeAngles().p, user:EyeAngles().y, 0))
		else
			self.gun:Switch(false)
		end
	end

	self.nextshoot2 = 0
	self.gun2 = ents.Create("minigun_dr2ent")
	self.gun2:SetPos(self:GetPos() + self:GetForward() * 10 + self:GetUp() * -4 + self:GetRight() * -10)
	self.gun2:SetAngles(self:GetAngles())
	self.gun2:Spawn()
	self.gun2:SetSolid(SOLID_NONE)
	self.gun2:SetParent(self)
	self.gun2._Think = function()
		local user = self:GetDriver()

		if not self:IsDroneDestroyed() and self:HasFuel() and user:IsValid() then		
			if user:KeyDown(IN_ATTACK) and self:HasAmmo() then
				self.gun2:Switch(true)
				if CurTime() > self.nextshoot2 then
					local bullet = {}
					bullet.Num = 1
					bullet.Src = self.gun2:GetPos() + self.gun2:GetForward() * 20
					bullet.Dir = self:GetDriverDirection()
					bullet.Spread = Vector(0.03, 0.03, 0.03)
					bullet.Tracer = 2	
					bullet.Force = 15
					bullet.Damage = 15
					bullet.Attacker = self.Owner
					 
					user:EmitSound("npc/strider/strider_minigun.wav", 100, math.random(200, 250))

					self.gun2:FireBullets(bullet)

					self:SetAmmo(self.Ammo - 1)

					self.nextshoot2 = CurTime() + 0.03
				end
			else
				self.gun2:Switch(false)
			end

			self.gun2:SetAngles(self:GetAngles() + Angle(user:EyeAngles().p < 0 and 0 or user:EyeAngles().p, user:EyeAngles().y, 0))
		else
			self.gun2:Switch(false)
		end
	end
end

function ENT:Think()
	self:_Think()
	

	if CLIENT then
		return 
	end

	if self.gun:IsValid() then self.gun._Think() end
	if self.gun2:IsValid() then self.gun2._Think() end

	self:NextThink(CurTime())
	return true
end