AddCSLuaFile()

ENT.Base = "drone_two_entity"
ENT.PrintName		= "Armed Racer Drone"
ENT.Category        = "Drones 2: Heavy"
ENT.AdminOnly = true
ENT.Spawnable = true

ENT.Speed = 5000
ENT.armor = 450

ENT.forward = 45
ENT.up = -5
ENT.cam_up = -12
ENT.cam_forward = 40

ENT.EnableSound = false
ENT.shouldConsumeFuel = false

ENT.Ammo = 3000
ENT.MaxAmmo = 3000

ENT.EnableSound = false
ENT.RotateSpeed = 300
ENT.MaxFuel = 400

ENT.HUD_hudColor = Color(255, 0, 0)
ENT.HUD_textColor = Color(155, 0, 0)

ENT.EnableParticles = true
ENT.NumParticles = 7
ENT.ParticleSize = 5
ENT.ParticleEffect = "dronestwo_particles2"
ENT.ParticleRadius = 1
ENT.PosParticles = { Vector(36, 8, -6), Vector(36, -8, -6), Vector(0, 5, -6), Vector(0, -5, -6),
					Vector(-20, 10, -3), Vector(-20, 0, -1), Vector(-20, -10, -3)
}

ENT.VelocityParticles = { Vector(0, 0, -20), Vector(0, 0, -20), Vector(0, 0, -20), Vector(0, 0, -20),
					Vector(-60, 0, 0), Vector(-60, 0, 0), Vector(-60, 0, 0) 
}

function ENT:Initialize()
	self:_Initialize("models/Mechanics/roboticslarge/k1.mdl", 1000)

	if CLIENT then
		self:SetElements({
			["cover2++++"] = { type = "Model", model = "models/props_combine/combineinnerwall001c.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(35.869, 0, -9.386), angle = Angle(-73.528, 0, 180), size = Vector(0.048, 0.078, 0.023), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["cover32+++"] = { type = "Model", model = "models/props_combine/combine_barricade_med01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(50.493, 1.654, 0.074), angle = Angle(180, 90, 10.855), size = Vector(0.075, 0.31, 0.075), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["jet+"] = { type = "Model", model = "models/xqm/jetenginepropeller.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(40.661, -11.711, -2.859), angle = Angle(0, 0, 0), size = Vector(1.621, 0.455, 0.455), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["cvt1+++"] = { type = "Model", model = "models/xqm/afterburner1.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(1.052, 4.718, -8.513), angle = Angle(-30.157, 0, 180), size = Vector(0.144, 0.144, 0.144), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["turbo2"] = { type = "Model", model = "models/xqm/afterburner1.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(-7.571, 0, -1.744), angle = Angle(90, 0, 0), size = Vector(0.633, 0.633, 1.442), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001", skin = 0, bodygroup = {} },
			["rad++"] = { type = "Model", model = "models/props_interiors/Radiator01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(61.615, 0, -0.889), angle = Angle(31.048, 0, 0), size = Vector(0.054, 0.152, 0.074), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["cover21"] = { type = "Model", model = "models/props_combine/combine_barricade_med01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(9.1, 13.173, -3.556), angle = Angle(-127.647, 85.074, -3.698), size = Vector(0.093, 0.648, 0.093), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["rad2"] = { type = "Model", model = "models/props_c17/gravestone003a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(60.047, 0, 0.728), angle = Angle(180, 0, 180), size = Vector(0.194, 0.194, 0.199), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/effects/splode_sheet", skin = 0, bodygroup = {} },
			["can"] = { type = "Model", model = "models/Combine_Helicopter/helicopter_bomb01.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(39.957, 0, 3.848), angle = Angle(-90, 0, 0), size = Vector(0.323, 0.323, 0.958), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["jet"] = { type = "Model", model = "models/xqm/jetenginepropeller.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(40.661, 11.71, -2.859), angle = Angle(0, 0, 0), size = Vector(1.621, 0.455, 0.455), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["cover32++"] = { type = "Model", model = "models/props_combine/combine_barricade_med01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(32.944, -0.285, 0), angle = Angle(0, 90, 0), size = Vector(0.118, 0.317, 0.118), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["cover2"] = { type = "Model", model = "models/props_combine/combineinnerwall001c.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(10.458, 0, -9.075), angle = Angle(-86.92, 0, -180), size = Vector(0.048, 0.087, 0.052), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["cover+"] = { type = "Model", model = "models/props_combine/combine_barricade_med01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(31.507, 5.927, 0.745), angle = Angle(60.196, -90.028, 0.239), size = Vector(0.112, 0.405, 0.112), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["skull"] = { type = "Model", model = "models/Gibs/HGIBS.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(32.914, 8.871, 4.354), angle = Angle(0, 0, -49.992), size = Vector(0.64, 0.032, 0.64), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["turb"] = { type = "Model", model = "models/xqm/jetengine.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(17.228, 0, -1.701), angle = Angle(0, 0, 0), size = Vector(1.294, 0.432, 0.432), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper001", skin = 0, bodygroup = {} },
			["cover32"] = { type = "Model", model = "models/props_combine/combine_barricade_med01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(50.493, -1.655, -0.075), angle = Angle(180, -90, -10.856), size = Vector(0.075, 0.31, 0.075), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["tri"] = { type = "Model", model = "models/hunter/triangles/075x075mirrored.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(43.998, -3.931, -0.914), angle = Angle(-90, 0, 0), size = Vector(0.277, 0.118, 0.277), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_tower01a", skin = 0, bodygroup = {} },
			["cv+"] = { type = "Model", model = "models/props_combine/headcrabcannister01a_skybox.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(60.72, -2.279, -2.333), angle = Angle(0, -112.232, -56.798), size = Vector(0.564, 0.564, 0.564), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["cover21+"] = { type = "Model", model = "models/props_combine/combine_barricade_med01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(9.1, -13.174, -3.556), angle = Angle(-127.647, -85.075, 3.697), size = Vector(0.093, 0.648, 0.093), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["cvt1"] = { type = "Model", model = "models/xqm/afterburner1.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(36.601, 7.486, -10.296), angle = Angle(-3.168, 0, -180), size = Vector(0.144, 0.144, 0.144), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["turbo"] = { type = "Model", model = "models/xqm/jetengine.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(38.863, -11.66, -2.725), angle = Angle(0, 0, 0), size = Vector(2.19, 0.446, 0.446), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_tower01a", skin = 0, bodygroup = {} },
			["cover2++"] = { type = "Model", model = "models/props_combine/combineinnerwall001c.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(51.221, 0, -4.783), angle = Angle(-73.342, 0, 180), size = Vector(0.048, 0.029, 0.029), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["cvt1++"] = { type = "Model", model = "models/xqm/afterburner1.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(1.052, -4.719, -8.513), angle = Angle(-30.157, 0, 180), size = Vector(0.144, 0.144, 0.144), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["cvt1+"] = { type = "Model", model = "models/xqm/afterburner1.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(36.601, -7.487, -10.296), angle = Angle(-3.168, 0, -180), size = Vector(0.144, 0.144, 0.144), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["covl2"] = { type = "Model", model = "models/props_combine/headcrabcannister01a_skybox.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(58.542, 3.529, 3.667), angle = Angle(-172.262, 0, 0), size = Vector(0.598, 0.598, 0.598), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["covl+"] = { type = "Model", model = "models/props_combine/combine_barricade_med01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(59.615, 2.085, -0.821), angle = Angle(180, 131.77, -180), size = Vector(0.056, 0.041, 0.056), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["skull+"] = { type = "Model", model = "models/Gibs/HGIBS.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(58.359, -0.287, 6.366), angle = Angle(76.268, 0, 0), size = Vector(0.032, 0.634, 0.814), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["cover21+++"] = { type = "Model", model = "models/props_combine/combine_barricade_med01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(35.217, 14.055, -3.934), angle = Angle(-127.701, 89.779, 3.039), size = Vector(0.093, 0.284, 0.093), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["turbo+"] = { type = "Model", model = "models/xqm/jetengine.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(38.863, 11.659, -2.725), angle = Angle(0, 0, 0), size = Vector(2.19, 0.446, 0.446), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_tower01a", skin = 0, bodygroup = {} },
			["cover"] = { type = "Model", model = "models/props_combine/combine_barricade_med01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(9.979, 6.007, -0.491), angle = Angle(58.25, -100.357, 12.168), size = Vector(0.112, 0.337, 0.112), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["cover32+"] = { type = "Model", model = "models/props_combine/combine_barricade_med01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(32.944, 0.284, 0), angle = Angle(0, -90, 0), size = Vector(0.118, 0.317, 0.118), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["cv"] = { type = "Model", model = "models/props_combine/headcrabcannister01a_skybox.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(60.72, 2.278, -2.333), angle = Angle(0, 112.231, -56.798), size = Vector(0.564, 0.564, 0.564), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["rad"] = { type = "Model", model = "models/props_interiors/Radiator01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(61.458, 0, 4.756), angle = Angle(-48.038, 0, 0), size = Vector(0.032, 0.112, 0.035), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["tri+"] = { type = "Model", model = "models/hunter/triangles/075x075mirrored.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(43.998, 3.93, -0.914), angle = Angle(-90, 0, 0), size = Vector(0.277, 0.118, 0.277), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combine_tower01a", skin = 0, bodygroup = {} },
			["rad21"] = { type = "Model", model = "models/props_c17/gravestone003a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(59.472, 0, 2.979), angle = Angle(161.216, 0, -180), size = Vector(0.189, 0.189, 0.12), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/effects/splode_sheet", skin = 0, bodygroup = {} },
			["bazze2+"] = { type = "Model", model = "models/props_combine/combine_barricade_med01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(41.297, 1.368, 1.95), angle = Angle(-169.517, 90, -180), size = Vector(0.085, 0.246, 0.085), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["cover2+"] = { type = "Model", model = "models/props_combine/combineinnerwall001c.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(39.269, 0, -7.582), angle = Angle(-71.207, 0, 180), size = Vector(0.048, 0.032, 0.029), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["covl"] = { type = "Model", model = "models/props_combine/combine_barricade_med01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(59.615, -2.086, -0.821), angle = Angle(180, -131.771, -180), size = Vector(0.056, 0.041, 0.056), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["bazze2"] = { type = "Model", model = "models/props_combine/combine_barricade_med01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(41.297, -1.369, 1.95), angle = Angle(-169.517, -90, -180), size = Vector(0.085, 0.246, 0.085), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["2"] = { type = "Model", model = "models/props_combine/combine_barricade_med02a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(33.957, 0, 6.248), angle = Angle(92.266, 0, -180), size = Vector(0.07, 0.07, 0.189), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["cover21++"] = { type = "Model", model = "models/props_combine/combine_barricade_med01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(35.217, -14.056, -3.934), angle = Angle(-127.701, -91.821, -4.573), size = Vector(0.093, 0.284, 0.093), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
			["rad+"] = { type = "Model", model = "models/props_interiors/Radiator01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(60.905, 0, 1.121), angle = Angle(0, 0, 0), size = Vector(0.098, 0.168, 0.196), color = Color(255, 255, 255, 255), surpresslightning = false, material = "models/props_combine/combinethumper002", skin = 0, bodygroup = {} },
			["bazze"] = { type = "Model", model = "models/props_combine/combine_booth_med01a.mdl", bone = "ValveBiped.Bip01_R_Hand", rel = "", pos = Vector(5, 0, 0), angle = Angle(90, 0, -180), size = Vector(0.096, 0.151, 0.231), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} }
		})
	
		return
	end

	self.gun = ents.Create("minigun_dr2ent")
	self.gun:SetPos(self:GetPos() + self:GetForward() * 15 + self:GetUp() * 6 + self:GetRight() * 10)
	self.gun:SetAngles(self:GetAngles())
	self.gun:Spawn()
	self.gun:SetSolid(SOLID_NONE)
	self.gun:SetParent(self)
	self.gun._Think = function()
		--Minigun and savers
		local user = self:GetDriver()

		if not self:IsDroneDestroyed() and self:HasFuel() and user:IsValid() then
			if user:KeyDown(IN_ATTACK) and self:HasAmmo() then
				self.gun:Switch(true)

				if CurTime() > self.nextshoot then
					local bullet = {}
					bullet.Num = 1
					bullet.Src = self.gun:GetPos() + self.gun:GetForward() * 50
					bullet.Dir = self.gun:GetForward()
					bullet.Spread = Vector(0.01, 0.01, 0.01)
					bullet.Tracer = 2	
					bullet.Force = 15
					bullet.Damage = 5
					bullet.Attacker = self.Owner
					 
					user:EmitSound("weapons/pistol/pistol_fire2.wav", 100, math.random(200, 250))

					self.gun:FireBullets(bullet)

					self:SetAmmo(self.Ammo - 1)

					self.nextshoot = CurTime() + 0.01
				end
			else
				self.gun:Switch(false)
			end

			//self.gun:SetAngles(self:GetAngles() + Angle(user:EyeAngles().p < 0 and 0 or user:EyeAngles().p, user:EyeAngles().y, 0))
		else
			self.gun:Switch(false)
		end
	end

	self.nextshoot2 = 0
	self.gun2 = ents.Create("minigun_dr2ent")
	self.gun2:SetPos(self:GetPos() + self:GetForward() * 15 + self:GetUp() * 6 + self:GetRight() * -10)
	self.gun2:SetAngles(self:GetAngles())
	self.gun2:Spawn()
	self.gun2:SetSolid(SOLID_NONE)
	self.gun2:SetParent(self)
	self.gun2._Think = function()
		local user = self:GetDriver()

		if not self:IsDroneDestroyed() and self:HasFuel() and user:IsValid() then	
			if user:KeyDown(IN_ATTACK) and self:HasAmmo() then
				self.gun2:Switch(true)
				if CurTime() > self.nextshoot2 then
					local bullet = {}
					bullet.Num = 1
					bullet.Src = self.gun2:GetPos() + self.gun2:GetForward() * 50
					bullet.Dir = self.gun2:GetForward()
					bullet.Spread = Vector(0.01, 0.01, 0.01)
					bullet.Tracer = 2	
					bullet.Force = 15
					bullet.Damage = 15
					bullet.Attacker = self.Owner
					 
					user:EmitSound("weapons/pistol/pistol_fire2.wav", 100, math.random(200, 250))

					self.gun2:FireBullets(bullet)

					self:SetAmmo(self.Ammo - 1)

					self.nextshoot2 = CurTime() + 0.03
				end
			else
				self.gun2:Switch(false)
			end

			//self.gun2:SetAngles(self:GetAngles() + Angle(user:EyeAngles().p < 0 and 0 or user:EyeAngles().p, user:EyeAngles().y, 0))
		else
			self.gun2:Switch(false)
		end
	end
end

function ENT:Think()
	self:_Think()
	
	if CLIENT and self:HasFuel() then
		self.WElements["jet"].angle.r = CurTime() * 20000
		self.WElements["jet+"].angle.r = CurTime() * 20000

		return 
	end

	local user = self:GetDriver()
	if user:IsValid() and user:KeyDown(IN_SPEED) and user:KeyDown(IN_FORWARD) and self:HasFuel() then
	    local ef = EffectData()
	    ef:SetOrigin(self:GetPos() + self:GetForward() * -32 + self:GetUp() * -2)
	    ef:SetStart(self:GetPos() + self:GetForward() * -12 + self:GetUp() * -2)
	    util.Effect("effect_dr2_flame", ef, true, true)
	end

	if CLIENT then
		return 
	end

	if self.gun:IsValid() then self.gun._Think() end
	if self.gun2:IsValid() then self.gun2._Think() end

	self:NextThink(CurTime())
	return true
end

local FLY_CONST = 586.5
local FUEL_REDUCTION = 0.002
function ENT:PhysicsSimulate(phys, delta)
	--Fly physics
	if CLIENT then return end
	if self:IsDroneDestroyed() then return SIM_NOTHING end
	if not self:HasFuel() then return SIM_NOTHING end

	local ang = phys:GetAngles()
	local avel = phys:GetAngleVelocity()
	local vel = phys:GetVelocity()

	local vecf = Vector(0, 0, 0)
	local angf = Vector(0, 0, 0)

	-- Fly
	vecf = vecf + self:GetUp() * (FLY_CONST + math.sin(CurTime() * 2) * 2)

	if self.Noise then
		local vec = VectorRand()
		vec.z = 0
		angf = angf + vec * math.sin(CurTime()) * 5
	end
 
	local angp = math.NormalizeAngle(ang.p)
	local angr = math.NormalizeAngle(ang.r)

	-- Controlls
	local user = self:GetDriver()
	if user:IsValid() then
		self.curSpeed = user:KeyDown(IN_SPEED) and math.Approach(self.curSpeed, 4, 0.01) or math.Approach(self.curSpeed, 1, 0.01)

		if user:KeyDown(IN_MOVELEFT) then angf = angf + Vector(-80, 0, self.RotateSpeed) end
		if user:KeyDown(IN_MOVERIGHT) then angf = angf + Vector(80, 0, -self.RotateSpeed) end

		if user:KeyDown(IN_JUMP) then 
			angf = angf + Vector(0, -100 * self.curSpeed, 0)
			vecf = vecf + vector_up * (self.Speed / 2) * self.curSpeed 
		end

		if user:KeyDown(IN_DUCK) then 
			angf = angf + Vector(0, 100 * self.curSpeed, 0)
			vecf = vecf - vector_up * (self.Speed / 2) * self.curSpeed 
		end

		if user:KeyDown(IN_FORWARD) then
			vecf = vecf + self:GetForward() * self.Speed * self.curSpeed + self:GetUp() * (self.Speed / 14) * self.curSpeed
			angf = angf + Vector(0, 10 * self.curSpeed, 0)
		end

		if user:KeyDown(IN_BACK) then
			vecf = vecf - self:GetForward() * self.Speed * self.curSpeed + self:GetUp() * (self.Speed / 14) * self.curSpeed
			angf = angf - Vector(0, 10 * self.curSpeed, 0)
		end
	end

	if self.shouldConsumeFuel then 
		self:SetFuel(self.Fuel - FUEL_REDUCTION * (vecf:Length() * 0.001)) 
	end

	angf = angf - Vector(angr, angp, 0) * 7

	angf = angf - avel * delta * 100
	vecf = vecf - vel * delta * 100

	return angf, vecf, SIM_GLOBAL_ACCELERATION
end