AddCSLuaFile()
ENT.Type = "anim"
ENT.Base = "base_anim"
ENT.Spawnable = false

local rSound = Sound("Missile.Accelerate")

function ENT:Draw()
	if SERVER then return end
	self:DrawModel()
end

if CLIENT then return end

function ENT:Initialize()
	self:SetModel("models/weapons/w_missile_closed.mdl")
	self:SetMaterial("models/props_combine/combinethumper001")
	self:SetMoveType(MOVETYPE_VPHYSICS)
	self:SetSolid(SOLID_VPHYSICS)
	self:PhysicsInit(SOLID_VPHYSICS)
	self:GetPhysicsObject():EnableDrag(false) 	
end

ENT.lvc = 1

function ENT:Think()
	self:NextThink(CurTime())
end

function ENT:PhysicsCollide(data,physobj)
	local ef = EffectData()
	ef:SetOrigin(self:GetPos())
	ef:SetAttachment(1)
	ef:SetEntity(self.Weapon)
	util.Effect("effect_projimp", ef, true, true)
	
	for i = 1, math.random(10, 20) do 
		util.Effect("effect_projtrails", ef, true, true)
	end	
	
	self:EmitSound("ambient/explosions/explode_"..math.random(1,4)..".wav", 500, 100)
	
	util.BlastDamage( self, self, self:GetPos(), 700, 1000 )
	
	util.ScreenShake(self.Entity:GetPos(), 500, 255, 0.5, 1200)
	
	self:Remove()
end

function ENT:OnRemove()
	self.Entity:StopSound(rSound)
end